<?php
##//////////////////////////////////////////////////////////////////
#//                           DIRECTORIES                       ///#
//////////////////////////////////////////////////////////////////##
function GetParamsString($params){
	if (is_array($params)){
		$str = [];
		foreach($params as $k=>$v){
			$str[] = urlencode($k)."=".urlencode($v);
		}
		$params = implode("&", $str);
	}
	if (strlen($params) && $params[0]!="?"){
		$params = "?".$params;
	}
	return $params;
}
function GetProjectDirectory($project=''){
    return DIR_PROJECTS.'/'.($project ? $project : ServerSettings::$Project).'/';
}

$_settingsCache = [];
function GetProjectUrl($page="", $params="", $useThisProject="") {
	global $_settingsCache;

	$useThisProject = $useThisProject ? $useThisProject : ServerSettings::$Project;

	if (ServerSettings::$Project === $useThisProject){
		$settings = ServerSettings::$current;
	}else{
		if (!isset($_settingsCache[$useThisProject])){
			$settings = new ServerSettings();
			$settings->Load();
			$settings->LoadEnvironment();
			$settings->LoadProject($useThisProject);
			$settings->LoadProject($useThisProject, ServerSettings::$Environment);
			$_settingsCache[$useThisProject] = $settings;
		}else{
			$settings = $_settingsCache[$useThisProject];
		}
	}

	if ($page == ServerSettings::GetCurrent('DefaultPage')) $page = "";


	$baseURL = '';

	if ($settings->Get('ProjectUrl')){
		$baseURL = $settings->Get('ProjectUrl');
	}else {
		$domains = $settings->Get('Domains');
		$domainProjectsVals = array_values($domains);
		$domain = array_search($useThisProject, $domains);

		if ($domain!==false){
			$settings->Set('ProjectUrl', ($settings->Get('https') ? 'https://' : 'http://').($settings->Get('www') ? 'www.' : '').$domain.'/');
			$baseURL = $settings->Get('ProjectUrl');
		}else if ($useThisProject == $settings->Get('DefaultProject')) {
			$baseURL = SITE_URL;
		} else {
			$baseURL = SITE_URL . GetProjectDirectory($useThisProject);
		}
	}

	$params = GetParamsString($params);
    return $baseURL.($page ? $page."/" : "").$params;
}

function GetDynamicDirectory($p=''){
    return GetProjectDirectory($p).DIR_DYNAMIC.'/';
}

function GetDynamicUrl($useThisProject=""){
    return GetProjectUrl('', '', $useThisProject).DIR_DYNAMIC.'/';
}

function GetActionUrl($Controller, $Action="", $params = "", $useThisProject=""){
	$params = GetParamsString($params);
    return GetProjectUrl('', '', $useThisProject).'do/'.$Controller.".".($Action ? $Action : $Controller)."/".$params;
}