<?php
function Login(){
	RequirePostFields('email', 'password');

	$user = User::Select(['Email'=>$_POST['email']]);
	if (count($user)){
		/** @var User $user */
		$user = $user[0];
		if ($user->Password == $user->HashPassword($_POST['password'])){
			if (isset($_POST['origin-url']) && $_POST['origin-url'] != '/'){
				$_SESSION['loginRedirectUrl'] = substr($_POST['origin-url'], 1);
			}

			return LoginProcess($user);
		}else{
			//Log::Write('Login failed: '.$user->Id, '', false);
            Redirect(GetProjectUrl('', ['login'=>'failed']));
		}
	}


    Redirect(GetProjectUrl('', ['login'=>'failed']));

	return null;
}

function FacebookLogin(){
	if (isset($_GET['origin-url']) && $_GET['origin-url'] != '/'){
		$_SESSION['loginRedirectUrl'] = substr($_GET['origin-url'], 1);
	}

	$_SESSION['fbReturnTo'] = GetActionUrl('Auth', 'FacebookLoginRedirect');
	$fb = FacebookHandler::getInstance();
	$fb->AddPermission(['public_profile','email']);
	$fb->Login();
}

function FacebookLoginRedirect(){
	$fb = FacebookHandler::getInstance();

	$fbUser = $fb->api('/me', 'GET', ['fields'=>'id,name,email,age_range,gender']);

	/** @var User[] $user */
	$user = [];

	if (isset($fbUser['id'])){
		$user = User::Select(['FacebookId'=>$fbUser['id']]);

		if (!count($user)){
			$user = User::Select(['Email'=>$fbUser['email']]);
			if (count($user)){
				/** @var User $userToUpdate */
				$userToUpdate = $user[0];
				$userToUpdate->FacebookId = $fbUser['id'];
				$userToUpdate->Save();
			}
		}


		if (count($user)){
			/** @var User $user */
			$user = $user[0];
			if (!$user->Avatar->Exists()){
				$user->GetImageFromFacebook();
			}
		}else{
			/** @var User $user */
			$user = new User();

			$user->DisplayName = $fbUser['name'];
			$user->Email = $fbUser['email'];
			$user->FacebookId = $fbUser['id'];
			$user->Status = UserStatus::Unconfirmed;

			if ($fbUser['gender']=='male'){
				$user->Gender = UserGender::Male;
			}else if ($fbUser['gender']=='female'){
				$user->Gender = UserGender::Female;
			}else{
				$user->Gender = UserGender::Undisclosed;
			}

			$user->Save();

			if (!$user->Id){
				throw new Exception("Failed to register user");
			}

			$user->GetImageFromFacebook();
		}

		if (!$user->CPF){
			$_SESSION['loginRedirectUrl'] = GetProjectUrl('Register', '', 'main');
		}

		$_POST['remember'] = 1;

		LoginProcess($user);
	}else{
		throw new Exception("Facebook login failed");
	}
}

/**
 * @param $user User
 */
function LoginProcess($user=null){
	if (!$user) $user = User::LoggedUser();
	if (!$user) die();

	$user->LastAccessDate = time();
	$user->Save();

	$user->LoginAs();
	if ($_POST['remember'] == 1)
		$user->SetCookies();

	if (isset($_SESSION['loginRedirectUrl'])){
		Redirect($_SESSION['loginRedirectUrl']);
		unset($_SESSION['loginRedirectUrl']);
	}else{
		Redirect(GetProjectUrl());
	}
}

function Logout(){
	User::Logout();

	if (isset($_GET['origin-url']) && $_GET['origin-url'] != '/'){
		$url = substr($_GET['origin-url'], 1);

		Redirect(GetProjectUrl().$url);
	}else{
		Redirect(GetProjectUrl());
	}
}

function PasswordChangeRequest(){
    $email = $_POST['email'];

    /** @var User[] $user */
    $user = User::Select(['email'=>$email]);
    if (count($user)){
        $user = $user[0];

        $time = time();
        $hash = $user->GetPasswordResetHash($time);
        $uid = $user->IdAsHash();

        $query = "?t=$time&h=$hash&u=$uid";

        $user->SendMail('Solicitação de troca de senha',
            EmailTemplate::RenderContent('PasswordResetRequest.html', ['user'=>$user, 'q'=>$query], 'app'),
            'ultra-password-reset-request');

        if (!$_POST['noredir']) Redirect(GetProjectUrl('MyProfile', ['login'=>'password-reset-request'], 'app'));

        return 1;
    }

    return 0;
}

function PasswordReset(){
    $id = User::IdFromHash($_GET['u']);
    $time = intval($_GET['t']);
    $hash = $_GET['h'];

    $user = new User($id);
    if ($user->Exists && $user->GetPasswordResetHash($time) === $hash){
        $newPassword = User::IdToHash(rand(4987, 496879), 10);

        $user->SetPassword($newPassword);
        $user->Save();

        $user->SendMail('Nova senha',
            EmailTemplate::RenderContent('PasswordReset.html', ['user'=>$user, 'password'=>$newPassword], 'app'),
            'ultra-password-reset');

        Redirect(GetProjectUrl('MyProfile', ['login'=>'password-reset'], 'app'));
    }
}