<?php
/**
 * Created by PhpStorm.
 * User: Daniel
 * Date: 13/03/2017
 * Time: 06:57
 */

function Session(){
	return PagSeguroHandler::sessions();
}


function Notify(){
	header("access-control-allow-origin: https://sandbox.pagseguro.uol.com.br");

	//print_r($_POST);

	if ($_POST['notificationType']=='transaction'){
		$result = PagSeguroHandler::xml('v2/transactions/notifications/'.$_POST['notificationCode'], 'get', null, true, true);

		$ref = intval($result['reference']);
		$status = intval($result['status']);

		if ($status!=3){
			echo "Status isn't paid, nothing to do here";
			die();
		}


		if ($result['type']==11){
			// Pagamento de assinatura pré aprovada
			$amount = floatval($result['grossAmount']);

			$sub = new Subscription($ref);

			if ($sub->Id && $sub->User && $sub->User->Id){
				$sub->User->BalanceOperation($sub->CreditsPerMonth, 'Plano '.$sub->Plan->Name.' - '.date('m/Y'));

                // Notify user via email
                $sub->User->SendMail('Pagamento realizado',
                    EmailTemplate::RenderContent('PaymentMade.html', ['user'=>$sub->User, 'amount'=>$amount], 'app'),
                    'ultra-payment');
			}else{
				echo "Sub not found";
			}
		}else if ($result['type']==1){
			// Compra avulsa

			$user = new User($ref);

			if ($user->Exists){
				if (!$user->CurrentSubscription){
					$plan = new Plan();
				}else{
					$plan = $user->CurrentSubscription->Plan;
				}

				$amount = floatval($result['grossAmount']);
				$credits = $plan->CalculateCreditsFromAmount($amount);

				$bo = $user->BalanceOperation($credits, 'Compra avulsa - '.$amount.' R$');

                // Notify user via email
                $user->SendMail('Pagamento realizado',
                    EmailTemplate::RenderContent('PaymentMade.html', ['user'=>$user, 'amount'=>$amount], 'app'),
                    'ultra-payment');
			}else{
				echo 'User not found';
			}
		}
	}

	die();
}