<?PHP

/**
 * @property integer Id
 * @property integer UserId
 * @property integer Type
 * @property integer Amount
 * @property integer Date
 * @property string Description
 **/
class BalanceOperation extends BaseModel {
	use MagicEntity;
	public static $databaseTable = 'balance-operation';

    public function getRelativeAmount(){
        return $this->Type == BalanceOperationType::CreditOrder ? $this->Amount : $this->Amount*-1;
    }
    public function getOperationString(){
        return $this->Type == BalanceOperationType::CreditOrder ? 'Crédito' : 'Débito';
    }
}

BalanceOperation::SetRelationships([
	'User'=> (new RelationshipManyToOne('User', 'UserId'))->Magic()->OnDelete('CASCADE')
]);

BalanceOperation::SetFields([
	(new IntegerField('Id'))
		->SetDatabaseDescriptor('int', 11)->AutoIncrement(true)->PrimaryKey(),

	(new IntegerField('UserId'))
		->SetDatabaseDescriptor('int', 11),

	(new IntegerField('Type'))
		->SetDatabaseDescriptor('tinyint', 2),

	(new IntegerField('Amount'))
		->SetDatabaseDescriptor('int', 11),

	(new IntegerField('Date'))
		->SetDatabaseDescriptor('int', 11),

	(new NotNullField('Description', ''))
		->SetDatabaseDescriptor('text')
]);