<?PHP

/**
 * @property integer UserId
 * @property integer GoodId
 * @property integer StartDateTime
 * @property integer EndDateTime
 *
 * @property User User
 * @property Good Good
 **/
class GoodOperator extends BaseModel {
	use MagicEntity;
	public static $Identifier = ['UserId', 'GoodId'];

	public static $databaseTable = 'good-operator';
	public static $insertWithId = true;
}

GoodOperator::SetRelationships([
	'User'=> (new RelationshipManyToOne('User', 'UserId'))->Autoload(true)->Magic()->OnDelete('CASCADE'),
	'Good'=> (new RelationshipManyToOne('Good', 'GoodId'))->Magic()->OnDelete('CASCADE'),
]);

GoodOperator::SetFields([
	(new IntegerField('UserId'))
		->SetDatabaseDescriptor('int', 11)->PrimaryKey(),

	(new IntegerField('GoodId'))
		->SetDatabaseDescriptor('int', 11)->PrimaryKey()
]);