<?PHP

/**
 * @property integer Id
 * @property string Name
 * @property string NamePlural
 * @property integer Gender
 * @property integer[] PlansAllowed
 *
 * @property Good[] Goods
 **/
class GoodType extends BaseModel {
	use MagicEntity;
	public static $databaseTable = 'good-type';
}


GoodType::SetRelationships([
	'Goods'=>(new RelationshipOneToMany('Good', 'Id', 'TypeId', true)),
]);

GoodType::SetFields([
	(new IntegerField('Id'))
		->SetDatabaseDescriptor('int', 11)->AutoIncrement(true)->PrimaryKey(),

	(new NotNullField('Name', ''))
		->SetDatabaseDescriptor('varchar', 128),

	(new NotNullField('NamePlural', ''))
		->SetDatabaseDescriptor('varchar', 128),

	(new IntegerField('Gender'))
		->SetDatabaseDescriptor('tinyint', 1),

	(new BooleanField('HasPeriod'))
		->SetDatabaseDescriptor('tinyint', 1),

	(new BooleanField('HasPickupAddress'))
		->SetDatabaseDescriptor('tinyint', 1),

	(new BooleanField('HasDestinationAddress'))
		->SetDatabaseDescriptor('tinyint', 1),

	(new JsonField('PlansAllowed'))
		->SetDatabaseDescriptor('text'),
]);