<?php
/**
 * Created by PhpStorm.
 * User: Daniel
 * Date: 13/03/2017
 * Time: 06:03
 */

class PagSeguroHandler {
	public static $sandbox = false;
	static $url = 'https://ws.pagseguro.uol.com.br/';
	static $sandboxUrl = 'https://ws.sandbox.pagseguro.uol.com.br/';

	static $token = '';
	static $email = '';

	public static function setCredentials($email, $token, $sandbox = false){
		self::$email = $email;
		self::$token = $token;
		self::$sandbox = $sandbox;
	}

	public static function json($path, $method, $data='', $dataIsRaw=false){
		$return = self::curl('json', $path, $method, $data, $dataIsRaw);

		$parsed = json_decode($return, true);

		return $parsed === null ? $return : $parsed;
	}

	public static function xml($path, $method, $data='', $dataIsRaw=false, $noType=false){
		$return = self::curl($noType ? '' : 'xml', $path, $method, $data, $dataIsRaw);

		$dataXML = simplexml_load_string($return);
		$json = json_encode($dataXML);
		$parsed = json_decode($json, true);

		return $parsed === null ? $return : $parsed;
	}


	public static function encodeXml($data, $root){
		if (!($root instanceof  SimpleXMLElement)){
			$root = new SimpleXMLElement("<$root/>");
		}

		if (is_array($data)){
			foreach ($data as $k=>$v){
				$el = $root->addChild($k);
				self::encodeXml($v, $el);
			}
		}else{
			$root[0] = $data;
		}

		return $root->asXML();
	}

	public static function curl($dataType, $path, $method, $data='', $dataIsRaw=false, $verbose=false){
		$url = self::$sandbox ? self::$sandboxUrl : self::$url;
		$url = $url . $path . "?email=" . self::$email . "&token=" . self::$token;

		$path = rtrim($path, '/ ');
		$path = ltrim($path, '/ ');

		$method = strtolower($method);

		$methodId = $method == 'post' ? CURLOPT_POST : ($method == 'put' ? CURLOPT_PUT : 0);

		if (!$dataIsRaw && $data){
			if ($dataType=='json'){
				$data = json_encode($data);
			}
		}

		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		if ($dataType)
			curl_setopt($ch, CURLOPT_HTTPHEADER, [
				"Content-Type: application/$dataType;charset=ISO-8859-1",
				"Accept: application/vnd.pagseguro.com.br.v3+$dataType;charset=ISO-8859-1"]);

		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

		if ($data){
			curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
		} else if ($data===null){

		} else {
			curl_setopt($ch, CURLOPT_POSTFIELDS, '');
		}

		if ($methodId) curl_setopt($ch, $methodId, true );

		if ($verbose){
			curl_setopt($ch, CURLOPT_VERBOSE, true);
			$verbose = fopen('php://temp', 'w+');
			curl_setopt($ch, CURLOPT_STDERR, $verbose);
		}

		$r = curl_exec($ch);

		if ($verbose){
			rewind($verbose);
			$verboseLog = stream_get_contents($verbose);

			echo $verboseLog;
		}

		return $r;
	}


	public static function javascript(){

		return (self::$sandbox ?
			'<script type="text/javascript" src="https://stc.sandbox.pagseguro.uol.com.br/pagseguro/api/v2/checkout/pagseguro.directpayment.js"></script>' :
			'<script type="text/javascript" src="https://stc.pagseguro.uol.com.br/pagseguro/api/v2/checkout/pagseguro.directpayment.js"></script>')
			."<script type=\"text/javascript\">
					Session.Do('Pagseguro', 'Session',{}, function (result) {
                        PagSeguroDirectPayment.setSessionId(result);
                    });</script>";
	}


	////// API 1to1
	public static function sessions(){
		return PagSeguroHandler::xml('sessions', 'post')['id'];
	}
}