<?php
/**
 * Created by PhpStorm.
 * User: Daniel
 * Date: 19/03/2017
 * Time: 22:38
 */

class EmailTemplate {
	/** @var Twig_Environment */
	private static $twig = null;

	public static function LoadTwig(){
		$loader = new Twig_Loader_Filesystem(GetDynamicDirectory('_shared').'emails');
		self::$twig = new Twig_Environment($loader, array(
			//'cache' => GetDynamicDirectory().'emails/cache',
		));
	}

	public static function RenderContent($file, $data, $project = null){
		if (!$data['url']) $data['url'] = GetProjectUrl('', '', $project);

		$content = self::$twig->render($file, $data);

		return self::FillWithContent($content);
	}

	public static function FillWithContent($content){
		return self::$twig->render('_template.html', array('content' => $content, 'url' => GetProjectUrl('', '', 'main')));
	}

	public static function GetMail($file, $data=[], $raw=false){
		$body = $raw ? self::FillWithContent($file) : self::RenderContent($file, $data);

		$mail = new Email();
		$mail->Message = $body;
		$mail->inlineCss = true;
		$mail->html = true;

		return $mail;
	}
}
EmailTemplate::LoadTwig();
