/*
 * Description: A script
 * Version: 0.1
 * Author: Daniel Andrade
 * Date: 26/01/2017
 * This code may not be reused without proper permission from its creator.
 */
/**
 * @property {number} Id
 * @property {string} Code
 * @property {number} TypeId
 * @property {number} OwnerId
 * @property {string} Title
 * @property {string} Brand
 * @property {string} Model
 * @property {string} Description
 * @property {number} Capacity
 * @property {number} CarryCapacity
 * @property {number} DefaultCost
 * @property {number} DefaultCostMeasurement
 * @property {number} VariableCost
 * @property {number} VariableCostMeasurement
 * @property {string} Observations
 * @property {string} Home
 * @property {number} PlansAllowed
 * @property {string} ImagesUrl
 * @property {string[]} Images
 * @property {GoodType} Type
 *
 * @property {string[]} _imagesToInclude
 * @property {string[]} _imagesToRemove
 *
 * @extends ORM.Entity
 * @constructor
 */
function Good(){
    this._imagesToInclude = [];
    this._imagesToRemove = [];
    this.Parent(null, arguments, Good);
}
Good.inherit(Entity);
Good.Attributes = [
    new Entity.Attributes.Integer('Id'),
    new Entity.Attributes.String('Code'),
    new Entity.Attributes.Integer('TypeId'),
    new Entity.Attributes.Integer('OwnerId'),
    new Entity.Attributes.String('Title'),
    new Entity.Attributes.String('Brand'),
    new Entity.Attributes.String('Model'),
    new Entity.Attributes.String('Description'),

    new Entity.Attributes.Float('Capacity'), // In people
    new Entity.Attributes.Integer('CarryCapacity'), // In kg
    
    new Entity.Attributes.Integer('DefaultCost'),
    new Entity.Attributes.Integer('DefaultCostMeasurement'),
    new Entity.Attributes.Integer('VariableCost'),
    new Entity.Attributes.Integer('VariableCostMeasurement'),
    
    new Entity.Attributes.String('Observations'),
    new Entity.Attributes.String('Home'),

    new Entity.Attributes.Integer('PlansAllowed'),
    new Entity.Attributes.Boolean('Hidden'),

    new Entity.Attributes.String('ImagesUrl'),
    new Entity.Attributes.Object('Images'),

    new Entity.Attributes.Entity('Type', false),
    new Entity.Attributes.EntityList('Operators', false),

    new Entity.Attributes.Object('_imagesToInclude'),
    new Entity.Attributes.Object('_imagesToRemove')
];
Entity.ClassMap.Register(Good);


Good.UsageMeasurement = {
    Kilometers: 1,
    Miles: 5,

    Minutes: 2,
    Hours: 3,
    Days: 4,

    _strings: {
        1: 'Kilômetro',
        5: 'Milha',
        2: 'Minuto de vôo',
        3: 'Hora',
        4: 'Dia'
    }
};





/**
 * @property {number} UserId
 * @property {number} GoodId
 * @property {User} User
 * @property {Good} Good
 *
 * @extends ORM.Entity
 * @constructor
 */
function GoodOperator(){
    this.Parent(null, arguments, GoodOperator);
}
GoodOperator.inherit(Entity);
GoodOperator.Attributes = [
    new Entity.Attributes.Integer('UserId'),
    new Entity.Attributes.Integer('GoodId'),
    new Entity.Attributes.Entity('User', false),
    new Entity.Attributes.Entity('Good', false),
];
Entity.ClassMap.Register(GoodOperator);