/*
 * Description: A script
 * Version: 0.1
 * Author: Daniel Andrade
 * Date: 26/01/2017
 * This code may not be reused without proper permission from its creator.
 */

/**
 * @property {number} Id
 * @property {string} Name
 * @property {string} NamePlural
 * @property {number} Gender
 *
 * @property {boolean} HasPeriod
 * @property {boolean} HasPickupAddress
 * @property {boolean} HasDestinationAddress
 *
 * @property {number[]} PlansAllowed
 *
 * @property {Good[]} Goods
 *
 * @extends ORM.Entity
 * @constructor
 */
function GoodType(){
    this.Parent(null, arguments, GoodType);
}
GoodType.inherit(Entity);
GoodType.Attributes = [
    new Entity.Attributes.Integer('Id'),
    new Entity.Attributes.String('Name'),
    new Entity.Attributes.String('NamePlural'),
    new Entity.Attributes.Integer('Gender'),

    new Entity.Attributes.Boolean('HasPeriod'),
    new Entity.Attributes.Boolean('HasPickupAddress'),
    new Entity.Attributes.Boolean('HasDestinationAddress'),

    new Entity.Attributes.Json('PlansAllowed'),
    new Entity.Attributes.EntityList('Goods', false)
];
Entity.ClassMap.Register(GoodType);

GoodType.Gender = {
    Male: 1,
    Female: 2
};