/*
 * Description: A script
 * Version: 0.1
 * Author: Daniel Andrade
 * Date: 26/01/2017
 * This code may not be reused without proper permission from its creator.
 */

/**
 * @property {number} Id
 * @property {number} Index
 * @property {string} Name
 * @property {number} MonthlyCost
 * @property {number} CreditsPerMonth
 * @property {number} MaxDependents
 * @property {number} CreditsBonus
 * @property {number} CreditsExpiryInMonths
 * @property {number} MinimumMembershipTime
 * @property {boolean} Active
 *
 * @extends ORM.Entity
 * @constructor
 */
function Plan(){
    this.Parent(null, arguments, Plan);
}
Plan.inherit(Entity);
Plan.Attributes = [
    new Entity.Attributes.Integer('Id'),
    new Entity.Attributes.Integer('Index'),
    new Entity.Attributes.String('Name'),
    new Entity.Attributes.Float('MonthlyCost'),
    new Entity.Attributes.Integer('MaxDependents'),
    new Entity.Attributes.Float('CreditsBonus'),
    new Entity.Attributes.Integer('CreditsExpiryInMonths'),
    new Entity.Attributes.Integer('MinimumMembershipTime'),
    new Entity.Attributes.Boolean('Active')
];
Entity.ClassMap.Register(Plan);

Plan.__pointsRatio = 1;
Plan.prototype.creditsPerMonth = function () {
    return Math.floor(Plan.__pointsRatio * this.MonthlyCost * (1+(this.CreditsBonus/100)));
};