<?php
/**
 * Created by PhpStorm.
 * User: Daniel
 * Date: 27/03/2017
 * Time: 21:13
 */

function Subscribe(){
	$user = User::LoggedUserOrDie();

	$plan = new Plan($_POST['plan']);

	$holder = new User(json_decode($_POST['holder'], true));
	$address = new Address(json_decode($_POST['address'], true));
	$holder->Address = $address;

	$hash = $_POST['hash'];
	$cardToken = $_POST['cardToken'];


	$sub = new Subscription();
	$sub->User = $user;
	$sub->Plan = $plan;
	$sub->StartDate = time();
	$sub->Status = 1;
	$sub->MonthlyCost = $plan->MonthlyCost;
	$sub->CreditsPerMonth = $plan->CreditsPerMonth();

	$result = $sub->Create($cardToken, $holder, $hash);

	if ($result){
		/** @var Subscription[] $activeSubs */
		$activeSubs = Subscription::Select([
			'UserId'=>$user->Id,
			new Filter('EndDate', 'NULL', 'IS', 'OR', false)
		]);

		foreach ($activeSubs as $activeSub){
			if ($activeSub->Id != $sub->Id){
				$activeSub->End();
			}
		}

		$user->CurrentSubscription = new Subscription($sub->Id);
		$user->Save();


        // Notify user via email
        $user->SendMail('Seu plano foi alterado!',
            EmailTemplate::RenderContent('PlanChange.html', ['user'=>$user], 'app'),
            'ultra-plan-change');

		return true;
	}

	return false;
}

function BuyCredits(){
	$user = User::LoggedUserOrDie();

	$holder = new User(json_decode($_POST['holder'], true));
	$address = new Address(json_decode($_POST['address'], true));
	$holder->Address = $address;

	$amount = intval($_POST['amount']);
	$hash = $_POST['hash'];
	$cardToken = $_POST['cardToken'];

	$sub = $user->CurrentSubscription;

	return $sub->BuyCredits($amount, $cardToken, $holder, $hash);
}