<?php

function Create(){
	$objData = $_POST['object'];
	$objData = json_decode($objData, true);
	$obj = new Reservation($objData);
	
	if ($obj->Id){
		$obj->Id = 0;
	}
	
	$user = User::LoggedUserOrDie();
	
	$obj->Renter = $user;
	$obj->Status = ReservationStatus::Pending;
	
	$obj->Save();


	// Notify user via email
    $user->SendMail('Sua reserva foi criada!',
        EmailTemplate::RenderContent('ReservationCreated.html', ['user'=>$user, 'reservation'=>$obj]),
        'ultra-reservation');
	
	return $obj->Id;
}

function Edit(){
    $user = User::LoggedUserOrDie();

    $objData = $_POST['object'];
    $objData = json_decode($objData, true);
    $obj = new Reservation($objData);

    $old = new Reservation($obj->Id);

    if (!$old->Exists || $old->RenterId != $user->Id){
        throw new Exception("Wrong user");
    }

    $obj->Save();

    return 1;
}

function Cancel(){
    $user = User::LoggedUserOrDie();
    $reservation = new Reservation($_POST['id']);

    if (!$reservation->Exists || $reservation->RenterId != $user->Id){
        throw new Exception("Wrong user");
    }

    if ($reservation->Status == ReservationStatus::Approved){
        $bo = $reservation->Renter->BalanceOperation(
            $reservation->getCost(),
            'Estorno: Reserva #'.str_pad($reservation->Id, 5, '0',STR_PAD_LEFT)
        );

        if ($bo->Id){
            $reservation->LoadRelationships(true);
            $reservation->Status = ReservationStatus::Canceled;
            $reservation->Save();
        }
    }else{
        $reservation->LoadRelationships(true);
        $reservation->Status = ReservationStatus::Canceled;
        $reservation->Save();
    }

    // Email status update to client
    $reservation->Renter->SendMail('A reserva #'.$reservation->Id.' foi cancelada.',
        EmailTemplate::RenderContent('ReservationUpdated.html', ['user'=>$reservation->Renter, 'reservation'=>$reservation], 'app'),
        'ultra-reservation-cancel');

    return $reservation->Serialize();
}