<h2>Adicionar Pontos</h2>

<div id="main">
	<div class="row">
		<div class="col-md-12">
			<h4>Selecione a Quatidade</h4>
		</div>
	</div>

	<div class="row">
		<div class="col-md-3 col-sm-4 col-xs-6 plan-card" v-for="amount in amounts" :class="{selected: selectedAmount == amount}" v-on:click="selectedAmount = amount">
			<h2 class="text-center">{{calculateCredits(amount).pad(0,0,null,'.')}} pontos</h2>
			<h4 class="text-center">{{amount.pad(0,2,null,'.')}} R$</h4>
		</div>
	</div>

	<br>

	<pagseguro-cc :user="user" ref="cc"></pagseguro-cc>
	<div class="row">
		<div class="col-md-8"></div>
		<div class="col-md-4">
			<span class="btn btn-block" :class="($refs.cc && $refs.cc.isFilled) ? 'btn-success' : 'btn-disabled'" v-on:click="purchase">
				<span class="glyphicon glyphicon-usd"></span>
				Adquirir Pontos
			</span>
		</div>
	</div>
</div>

<?=VueParser::Inline('entity/AddressEdit')?>
<?=VueParser::Inline('PagseguroCC')?>
<?=PagSeguroHandler::javascript()?>
<?=ScriptDependency::Current()->IncludeScript('entities/User')?>
<?=ScriptDependency::Current()->IncludeScript('libs/jquery.payment.min')?>

<script type="application/json" id="user-json"><?=json_encode(User::LoggedUser()->Serialize())?></script>
<script type="application/json" id="plans-json"><?=json_encode(BaseModel::SerializeArray(Plan::Select(['Active'=>1], '`Index` ASC')))?></script>
<script>
	Session.CurrentUser.FillFromArray(InlineJsonToObject('user'));

	/** @var Plan[] **/
	var plans = InlineJsonToEntityList('plans');

	var mainVM = new Vue({
		el: '#main',
		data: {
			user: Session.CurrentUser,
			amounts: [
			    //5,
				100,
				500,
				1000,
				2000
			],
			selectedAmount: null
		},
		computed: {
		},
		methods: {
            calculateCredits: function (price) {
                var multiplier = 1;
                if (this.user.CurrentSubscription){
                    if (this.user.CurrentSubscription.Plan.CreditsBonus){
                        multiplier = 1+(this.user.CurrentSubscription.Plan.CreditsBonus/100);
                    }
                }

                return Math.floor(Plan.__pointsRatio * price * multiplier);
            },
			purchase: function () {
				if (!this.selectedAmount){
					toast('error', 'Selecione uma quantia', 'Erro', 15000);
					return;
				}
				if (!this.$refs.cc.isFilled){
					toast('error', 'Preencha seus dados', 'Erro', 15000);
					return;
				}

				var holder = this.$refs.cc.holder;
				var address = this.$refs.cc.address;
				var hash = this.$refs.cc.getHash();
				var amount = this.selectedAmount;

				Loading.Show('Validando cartão...');

				this.$refs.cc.getCreditCardToken(function (token) {
					if (!token){
						toast('error', 'Cartão de crédito rejeitado!', 'Erro', 15000);
                        Loading.Hide();
						return;
					}

					Loading.Show('Processando assinatura...');

					Session.Do('Payment', 'BuyCredits',{
						holder: JSON.stringify(holder.Serialize()),
						address: JSON.stringify(address.Serialize()),
						cardToken: token,
						hash: hash,
						amount: amount
					}, function (result) {
						Loading.Hide();

						if (result){
							toast('success', '', 'Sucesso', 15000);
                            window.location = "/MyPlan";
						}
					});
				});
			}
		},
		mounted: function () {
		}
	});
</script>