<h2>Upgrade plano</h2>

<div id="main">
	<div class="row">
		<div class="col-md-12">
			<h4>Selecione o Plano</h4>
		</div>
	</div>

	<div class="row">
		<div class="col-md-3 col-sm-4 col-xs-6 plan-card" v-for="plan in plans" :class="{selected: selectedPlan == plan}" v-on:click="selectPlan(plan)">
			<h3 class="text-center">{{plan.Name}}</h3>
			<h3 class="text-center">{{plan.creditsPerMonth().pad(0,0,null,'.')}} pontos</h3>
			<h4 class="text-center">{{plan.MonthlyCost.pad(0,2,null,'.')}} R$</h4>
		</div>
	</div>

	<br>

	<pagseguro-cc :user="user" ref="cc"></pagseguro-cc>
	<div class="row">
		<div class="col-md-8">
            <input type="checkbox" v-model="accept"> Estou de acordo com a
            <a href="/dynamic/ChargePolicy.html" target="_blank">Política de Cobrança</a>
        </div>
		<div class="col-md-4">
			<span class="btn btn-block" :class="($refs.cc && $refs.cc.isFilled) ? 'btn-success' : 'btn-disabled'" v-on:click="subscribe">
				<span class="glyphicon glyphicon-usd"></span>
				Assinar
			</span>
		</div>
	</div>
</div>

<?=VueParser::Inline('entity/AddressEdit')?>
<?=VueParser::Inline('PagseguroCC')?>
<?=PagSeguroHandler::javascript()?>
<?=ScriptDependency::Current()->IncludeScript('entities/User')?>
<?=ScriptDependency::Current()->IncludeScript('libs/jquery.payment.min')?>

<script type="application/json" id="user-json"><?=json_encode(User::LoggedUser()->Serialize())?></script>
<script type="application/json" id="plans-json"><?=json_encode(BaseModel::SerializeArray(Plan::Select(['Active'=>1], '`Index` ASC')))?></script>
<script>
	Session.CurrentUser.FillFromArray(InlineJsonToObject('user'));

	/** @var Plan[] **/
	var plans = InlineJsonToEntityList('plans');

	var mainVM = new Vue({
		el: '#main',
		data: {
			user: Session.CurrentUser,
			plans: plans,
			selectedPlan: null,
            accept: false
		},
		computed: {
		},
		methods: {
			selectPlan: function (plan) {
                /*if (this.user.CurrentSubscription && this.user.CurrentSubscription.Plan.Id == plan.Id){
					toast('error', 'Esse já é seu plano', 'Erro', 15000);
					return;
				}else if (this.user.CurrentSubscription && this.user.CurrentSubscription.Plan.Index >= plan.Index){
                    toast('error', 'Para migrar para um plano inferior entre em contato conosco', 'Erro', 25000);
                    return;
                }*/

				this.selectedPlan = plan;
			},
			subscribe: function () {
				if (!this.accept){
					toast('error', 'Aceite a política de cobrança', 'Erro', 15000);
					return;
				}
                if (!this.selectedPlan){
                    toast('error', 'Selecione um plano', 'Erro', 15000);
                    return;
                }
				if (!this.$refs.cc.isFilled){
					toast('error', 'Preencha seus dados', 'Erro', 15000);
					return;
				}

				var holder = this.$refs.cc.holder;
				var address = this.$refs.cc.address;
				var hash = this.$refs.cc.getHash();
				var plan = this.selectedPlan.Id;

				Loading.Show('Validando cartão...');

				this.$refs.cc.getCreditCardToken(function (token) {
					if (!token){
						toast('error', 'Cartão de crédito rejeitado!', 'Erro', 15000);
						return;
					}

					Loading.Show('Processando assinatura...');

					Session.Do('Payment', 'Subscribe',{
						holder: JSON.stringify(holder.Serialize()),
						address: JSON.stringify(address.Serialize()),
						cardToken: token,
						hash: hash,
						plan: plan
					}, function (result) {
						Loading.Hide();

						if (result){
							toast('success', '', 'Sucesso', 15000);
							window.location = "/MyPlan";
						}
					});
				});
			}
		},
		mounted: function () {
		}
	});
</script>