<h2>Meus Bens</h2>

<div id="plans">
	<entity-manager ref="manager" model="Good" :order="order" :filter="filter" v-on:create="create" :remove-enabled="true">
		<template slot="table-head">
			<th>Código</th>
			<th>Tipo</th>
			<th>Marca</th>
			<th>Modelo</th>
			<th class="hidden-xs">Título</th>
		</template>
		<template slot="table-item" scope="data">
			<td>{{data.item.Code}}</td>
			<td>{{data.item.Type.Name}}</td>
			<td>{{data.item.Brand}}</td>
			<td>{{data.item.Model}}</td>
			<td class="hidden-xs">{{data.item.Title}}</td>
		</template>
		<template slot="edit" scope="data">
			<h4>Editar Bem</h4>

			<good-edit v-model="data.item" upload-url="/do/Good.ImageUpload" :types="types" :code-disabled="true"></good-edit>
			<good-operator-edit v-model="data.item"></good-operator-edit>
		</template>
	</entity-manager>
</div>

<?=ScriptDependency::Current()->IncludeScript('entities/Good')?>

<?=VueParser::Inline('EntityManager')?>
<?=VueParser::Inline('FileUploader')?>
<?=VueParser::Inline('entity/GoodEdit')?>
<?=VueParser::Inline('entity/GoodOperatorEdit')?>

<script type="application/json" id="types-json"><?=json_encode(BaseModel::SerializeArray(GoodType::Select()))?></script>

<script>
	var goodTypes = InlineJsonToEntityList('types');


	var plansVM = new Vue({
		el: '#plans',
		data: {
			order: 'TypeId ASC',
			measurements: Good.UsageMeasurement,
			uploads: [],
			tempUrl: '',
			types: goodTypes,
			filter: {
				OwnerId: Session.CurrentUser.Id
			}
		},
		computed: {
		},
		methods: {
			create: function (newGood) {
				newGood.OwnerId = Session.CurrentUser.Id
			}
		},
		mounted: function () {
		}
	});
</script>