<h2>Meu Plano</h2>

<div id="main">
	<div class="no-select" v-if="sub">
		<div class="row">
			<div class="col-sm-6 col-xs-12">
				<h3>Seu plano atual é: {{sub.Plan.Name}}</h3>

				<div class="row">
					<div class="col-md-4 col-sm-6 col-xs-12">
						<div class="info-item">
                            <label>Mensalidade</label><br>
							<small class="glyphicon glyphicon-usd"></small> {{sub.MonthlyCost.pad(0,2)}} R$/mês
						</div>
					</div>
					<div class="col-md-4 col-sm-6 col-xs-12">
						<div class="info-item">
                            <label>Pontos por mês</label><br>
							<small class="glyphicon glyphicon-plus"></small> {{sub.CreditsPerMonth}} pts/mês
						</div>
					</div>
					<div class="col-md-4 col-sm-6 col-xs-12">
						<div class="info-item">
                            <label>Data de adesão</label><br>
							<small class="glyphicon glyphicon-calendar"></small> {{sub.StartDate.format('d/m/Y')}}
						</div>
					</div>
					<div class="col-md-12">
						<br>
						<a href="/Checkout" class="btn btn-primary pull-right">
							<span class="glyphicon glyphicon-usd"></span> Trocar de plano
						</a>
					</div>
				</div>

                <h3>Histórico de Assinaturas</h3>
                <paged-table :items="subs" :results-per-page="4">
                    <template slot="head">
                        <tr>
                            <th>Plano</th>
                            <th style="width:200px;">Início</th>
                            <th style="width:200px;">Fim</th>
                        </tr>
                    </template>
                    <template slot="item" scope="data">
                        <tr :style="{color: data.item.EndDate ? '#aaa' : ''}">
                            <td>
                                {{data.item.Plan.Name}}
                                (R$ {{data.item.MonthlyCost.pad(0,2,null,'.')}}/{{data.item.CreditsPerMonth.pad(0,0,null,'.')}} pts)
                            </td>
                            <td>
                                {{data.item.StartDate.format('d/m/Y H:i:s')}}
                            </td>
                            <td>
                                {{data.item.EndDate ? data.item.EndDate.format('d/m/Y H:i:s') : 'Ainda ativa'}}
                            </td>
                        </tr>
                    </template>
                </paged-table>
			</div>
			<div class="col-sm-6 col-xs-12">
				<h3>Extrato</h3>
				<paged-table :items="bos" :results-per-page="8">
					<template slot="head">
						<tr>
							<th style="width:30%">Data</th>
							<th>Descrição</th>
							<th style="width:100px;">Valor</th>
						</tr>
					</template>
					<template slot="item" scope="data">
						<tr :class="data.item.Type == 2 ? 'text-success' : (data.item.Type == 1 ? 'text-danger' : '')">
							<td>
								<span class="hidden-xs">
									{{data.item.Date.format('d/m/Y H:i:s')}}
								</span>
								<span class="visible-xs">
									{{data.item.Date.format('d/m/Y')}} <br>
									{{data.item.Date.format('H:i:s')}}
								</span>
							</td>
							<td>
								{{data.item.Description}}
							</td>
							<td>
								{{data.item.Amount}} pontos
							</td>
						</tr>
					</template>
				</paged-table>
			</div>
		</div>
	</div>
	<div v-else>

		<a href="/Checkout" class="btn btn-lg btn-block btn-primary" style="font-size: 1.6em">
			Escolha seu plano! <span class="glyphicon glyphicon-usd"></span>
		</a>
	</div>
</div>

<style>
	.info-item {
		padding: 10px;
		transition: all .5s;
		background: rgba(255, 255, 255, 0);
	}
	.info-item:hover {
		background: rgba(255, 255, 255, .2);
	}
	.info-item .glyphicon {
		margin-right: 10px;
	}
</style>

<?=ScriptDependency::Current()->IncludeScript('entities/BalanceOperation')?>
<script>
	var mainVM = new Vue({
		el: '#main',
		data: {
			user: Session.CurrentUser,
			sub: Session.CurrentUser.CurrentSubscription,
			subs: [],
			bos: []
		},
		computed: {
		},
		methods: {
		},
		mounted: function () {
			var vm = this;

			Subscription.Select(function (r) {
				vm.subs = r;
			}, {
				filter: {
					UserId: Session.CurrentUser.Id
				},
				order: 'Id DESC'
			});

			BalanceOperation.Select(function (r) {
			    r.unshift(new BalanceOperation({
                    Type: 0,
                    Amount: Session.CurrentUser.Balance,
                    Date: Math.round(Date.now()/1000),
                    Description: "Saldo"
                }));
				vm.bos = r;
			}, {
				filter: {
					UserId: Session.CurrentUser.Id
				},
				order: 'Date DESC'
			});
		}
	});
</script>