<h2>Meu Perfil</h2>

<div id="main">
	<h4>Detalhes</h4>

	<div class="row">
		<div class="col-sm-6 col-xs-12">
			<label>Nome Completo</label>
			<input class="form-control" v-model="user.FullName">
		</div>
		<div class="col-sm-6 col-xs-12">
			<label>Nome de Exibição</label>
			<input class="form-control" v-model="user.DisplayName">
		</div>
	</div>
	<div class="row">
		<div class="col-sm-6 col-xs-12">
			<label>Email</label>
			<input type="email" class="form-control" v-model="user.Email">
		</div>
		<div class="col-sm-6 col-xs-12">
			<label>Resetar Senha</label>
			<input class="form-control" v-model="user.SetPassword"
			       v-popover.top.focus="'Se prenchido irá alterar sua senha'">
		</div>
	</div>
	<div class="row">
		<div class="col-sm-3 col-xs-6">
			<label>Gênero</label>
			<select class="form-control" v-model="user.Gender">
				<option value="">Escolha...</option>
				<option value="1">Masculino</option>
				<option value="2">Feminino</option>
				<option value="3">Não binário</option>
				<option value="4">Prefiro Não informar</option>
			</select>
		</div>
		<div class="col-sm-3 col-xs-6">
			<label v-popover.top.hover="'Para alterar essa informação entre em contato com o suporte.'">
				CPF
				<small class="glyphicon glyphicon-question-sign"></small>
			</label>
			<input type="tel" class="form-control" v-model="user.CPF" disabled="disabled">
		</div>
		<div class="col-sm-3 col-xs-6">
			<label>Telefone</label>
			<telephone-input class="form-control" v-model="user.Telephone"></telephone-input>
		</div>
		<div class="col-sm-3 col-xs-6">
			<label v-popover.top.hover="user.Birthday ? 'Para alterar essa informação entre em contato com o suporte.' : ''">
				Nascimento
				<small class="glyphicon glyphicon-question-sign" v-if="user.Birthday"></small>
			</label>
			<date-input class="form-control" v-model="user.Birthday" :disabled="user.Birthday ? true : false" />
		</div>
	</div>

	<h4>Endereço</h4>
	<address-edit v-model="user.Address"></address-edit>
	
	<br>
	<div class="row">
		<div class="col-sm-9 col-xs-6"></div>
		<div class="col-sm-3 col-xs-6">
			<div class="btn btn-block btn-success" v-on:click="save">
				Salvar
				<span class="glyphicon glyphicon-ok"></span>
			</div>
		</div>
	</div>
</div>

<?=VueParser::Inline('entity/AddressEdit')?>
<?=ScriptDependency::Current()->IncludeScript('entities/User')?>
<script type="application/json" id="user-json"><?=json_encode(User::LoggedUser()->Serialize())?></script>
<script>
	Session.CurrentUser.FillFromArray(InlineJsonToObject('user'));

	var mainVM = new Vue({
		el: '#main',
		data: {
			user: Session.CurrentUser
		},
		computed: {
		},
		methods: {
			save: function () {
				this.user.Save();
			}
		},
		mounted: function () {
		}
	});
</script>