<h2>Minhas reservas</h2>

<div id="main">
	<pane ref="table">
		<paged-table :items="filteredReservations">
			<template slot="head">
				<tr>
					<th style="width:100px;">Id</th>
					<th style="width:20%;">Bem</th>
					<th class="hidden-xs" style="width:300px;">Data</th>
					<th style="width:100px">Custo</th>
					<th>Status</th>
					<th style="width:75px;"></th>
				</tr>
			</template>
			<template slot="item" scope="data">
				<tr>
					<td>{{data.item.Id.pad(3)}}</td>
					<td>
						{{data.item.Good.Brand}} {{data.item.Good.Model}}
						<i style="color: #666">({{data.item.Good.Code}})</i>
					</td>
					<td class="hidden-xs">
						<template v-if="data.item.StartDateTime.getTime() == data.item.EndDateTime.getTime()">
							{{data.item.StartDateTime.format('d/m/Y - H:i:s')}}
						</template>
						<template v-else-if="data.item.StartDateTime.format('d/m/Y') == data.item.EndDateTime.format('d/m/Y')">
							{{data.item.StartDateTime.format('d/m/Y')}}:
							{{data.item.StartDateTime.format('H:i:s')}} ~
							{{data.item.EndDateTime.format('H:i:s')}}
						</template>
						<template v-else>
							De: {{data.item.StartDateTime.format('d/m/Y - H:i:s')}} <br>
							Até: {{data.item.EndDateTime.format('d/m/Y - H:i:s')}}
						</template>
					</td>
					<td>
						{{data.item.getCost()}} pontos
					</td>
					<td :class="'text-'+status._classes[data.item.Status]">
						{{status._strings[data.item.Status]}}
					</td>
					<td>
						<div class="btn btn-sm btn-block btn-primary" v-on:click="edit(data.item)"
						     v-popover.top.hover="'Detalhes'">
							<span class="glyphicon glyphicon-eye-open"></span>
						</div>
					</td>
				</tr>
			</template>
		</paged-table>
	</pane>
	<pane ref="edit" :expanded="false">
		<template v-if="editing">
			<h3>Reserva {{editing.Id.pad(5)}}</h3>

			<div class="row" v-if="!editEnabled">
				<div class="col-sm-6 col-xs-12">
					<h4>Bem</h4>
					<b>Código:</b> {{editing.Good.Code}}<br>

					<b>Modelo:</b> {{editing.Good.Brand}} {{editing.Good.Model}}<br>

					<b>Tipo:</b> {{editing.Good.Type.Name}}<br>

					<b>Custo:</b> {{editing.Good.DefaultCost}}
					+ {{editing.Good.VariableCost}}/{{measurements._strings[editing.Good.VariableCostMeasurement]}}<br>

					<br>

					<template v-if="editing.PickupAddress && editing.PickupAddress.Street">
						<h4>Endereço</h4>

						{{editing.PickupAddress.Street}}, {{editing.PickupAddress.Number}} {{editing.PickupAddress.NumberComplement}} <br>
						{{editing.PickupAddress.Neighborhood}}, {{editing.PickupAddress.PostalCode}} <br>
						{{editing.PickupAddress.City}} - {{editing.PickupAddress.State}}<br>
						<br>
					</template>
				</div>

				<div class="col-sm-6 col-xs-12">
					<h4>Reserva</h4>
					<b>Período:</b>
					<template v-if="editing.StartDateTime.getTime() == editing.EndDateTime.getTime()">
						{{editing.StartDateTime.format('d/m/Y - H:i:s')}}
					</template>
					<template v-else-if="editing.StartDateTime.format('d/m/Y') == editing.EndDateTime.format('d/m/Y')">
						{{editing.StartDateTime.format('d/m/Y')}},
						{{editing.StartDateTime.format('H:i:s')}} ~
						{{editing.EndDateTime.format('H:i:s')}}
					</template>
					<template v-else>
						De: {{editing.StartDateTime.format('d/m/Y - H:i:s')}} -
						Até: {{editing.EndDateTime.format('d/m/Y - H:i:s')}}
					</template>
					<br>

					<div class="row">
						<div class="col-md-6" v-if="editing.Meta.pickupPlace">
							<label>Origem:</label><br>
							<a :href="editing.Meta.pickupPlace.url" target="_blank" class="glyphicon glyphicon-map-marker"
							   v-popover.hover.top.body="editing.Meta.pickupPlace.formatted_address"></a>
							{{editing.Meta.pickupPlace.name}}
						</div>
						<div class="col-md-6" v-if="editing.Meta.destinationPlace">
							<label>Destino:</label><br>
							<a :href="editing.Meta.destinationPlace.url" target="_blank" class="glyphicon glyphicon-map-marker"
							   v-popover.hover.top.body="editing.Meta.destinationPlace.formatted_address"></a>
							{{editing.Meta.destinationPlace.name}}
						</div>

						<div class="col-md-12" v-if="editing.Meta.distance">
							<label>Distância estimada:</label> {{editing.Meta.distance}} km
						</div>
					</div>

					<b>Custo Total:</b> {{editing.getCost()}} pontos<br>
					<small>
						{{editing.FixedCredits}} + {{editing.VariableCredits}}
						<template v-if="editing.ExtraCredits">+ {{editing.ExtraCredits}}</template>
						= {{editing.getCost()}} pontos
					</small>
					<br>

					<b>Status:</b>
					<span :class="'text-'+status._classes[editing.Status]">{{status._strings[editing.Status]}}</span><br>

					<template v-if="editing.CheckInTime">
						<b>Check-in:</b> {{editing.CheckInTime ? editing.CheckInTime.format('d/m/Y - H:i:s') : '-'}}<br>
					</template>

					<template v-if="editing.CheckOutTime">
						<b>Check-out:</b> {{editing.CheckOutTime ? editing.CheckOutTime.format('d/m/Y - H:i:s') : '-'}}<br>
					</template>

					<div class="form-group" v-if="editing.Observations">
						<label>Observações:</label>
						<pre>{{editing.Observations}}</pre>
					</div>
				</div>
			</div>

            <reservation-edit :value="editing" v-show="editEnabled" ref="editReservation"></reservation-edit>

			<!-- footer-->
			<br>
			<div class="row">
				<div class="col-sm-3 col-xs-6">
					<div class="btn btn-block btn-warning" v-on:click="cancelEditing">
						<span class="glyphicon glyphicon-chevron-left"></span>
						Voltar
					</div>
				</div>
                <div class="col-sm-3 hidden-xs">

                </div>
                <div class="col-sm-3 col-xs-6">
                    <div class="btn btn-block btn-danger" v-on:click="cancel(editing)" v-if="!editEnabled && canCancel">
                        Cancelar
                        <span class="glyphicon glyphicon-remove"></span>
                    </div>
                    <div class="btn btn-block btn-warning" v-on:click="editEnabled = !editEnabled" v-if="editEnabled">
                        Descartar mudanças
                        <span class="glyphicon glyphicon-remove"></span>
                    </div>
                </div>
                <div class="col-sm-3 col-xs-6" v-if="!editEnabled && canEdit">
                    <div class="btn btn-block btn-info" v-on:click="editEnabled = !editEnabled">
                        Editar
                        <span class="glyphicon glyphicon-pencil"></span>
                    </div>
                </div>
                <div class="col-sm-3 col-xs-6" v-if="editEnabled">
                    <div class="btn btn-block btn-success" v-on:click="saveChanges">
                        Salvar
                        <span class="glyphicon glyphicon-check"></span>
                    </div>
                </div>
			</div>
		</template>
	</pane>
</div>

<?=VueParser::Inline('EntityManager')?>
<?=VueParser::Inline('entity/AddressEdit')?>
<?=VueParser::Inline('entity/ReservationEdit')?>

<?=ScriptDependency::Current()->IncludeScript('entities/Plan')?>
<?=ScriptDependency::Current()->IncludeScript('entities/Reservation')?>
<?=ScriptDependency::Current()->IncludeScript('Components/Map')?>

<script>
	var mainVM = new Vue({
		el: '#main',
		data: {
			items: [],
			selectedStatus: null,

			measurements: Good.UsageMeasurement,
			status: Reservation.Status,

			editing: null,
			editingIdx: 0,
            editEnabled: false
		},
		computed: {
			filteredReservations: function () {
				var vm = this;

				if (vm.selectedStatus === null){
					return vm.items;
				}

				return vm.items.filter(function (e) {
					return e.Status === vm.selectedStatus;
				});
			},

            canCancel: function () {
                return this.editing && (this.editing.Status === Reservation.Status.Pending || this.editing.Status === Reservation.Status.Approved);
            },

            canEdit: function () {
                return this.editing && this.editing.Status === Reservation.Status.Pending;
            }
		},
		methods: {
			edit: function (item) {
			    this.editEnabled = false;

				this.editing = new Reservation(item.Serialize());
				this.editingIdx = this.items.indexOf(item);

				this.$refs.table.hideNext();
				this.$refs.edit.showNext();
			},
			cancelEditing: function () {
				this.$refs['table'].show();
				this.$refs['edit'].hide();
			},

            saveChanges: function () {
                var vm = this;

                if (this.$refs.edit && this.$refs.editReservation.temp){
                    this.editing.FillFromArray(this.$refs.editReservation.temp.Serialize());
                }

                Loading.Show('Salvando...');

                Session.Do('Reservation', 'Edit',{
                    object: JSON.stringify(this.editing.Serialize())
                }, function (result) {
                    Loading.Hide();
                    if (result===1){
                        vm.editEnabled = false;
                        toast('success', 'Reserva editada!', 'Sucesso', 15000)
                    }else{
                        toast('error', '', 'Erro', 15000)
                    }
                });
            },

            cancel: function (reservation) {
                var vm = this;

                Loading.Show('Cancelando...');
                Session.Do('Reservation', 'Cancel',{
                    id: reservation.Id
                }, function (result) {
                    Loading.Hide();

                    if (result && result.Id){
                        reservation.FillFromArray(result);
                    }else{
                        toast('error', '', 'Erro', 15000)
                    }
                });
            }
		},
		mounted: function () {
			var vm = this;

			Loading.Show();
			Reservation.Select(function (data) {
				Loading.Hide();
				vm.items = data;
			}, {
				filter: {
					RenterId: Session.CurrentUser.Id
				},
				order: 'Id DESC'
			})
		}
	});
</script>