<h2>Buscar Bens</h2>

<div id="main">
	<pane ref="list">
		<div class="text-center" style="margin-bottom: 15px; visibility: hidden" :style="{visibility: 'visible'}">
			<div class="btn-group">
				<button class="btn" :class="selectedType === null ? 'btn-primary' : 'btn-default'" v-on:click="selectType(null)">Todos</button>
				<button class="btn" :class="selectedType === type ? 'btn-primary' : 'btn-default'" v-for="type in types"
				        v-on:click="selectType(type)">{{type.NamePlural}}</button>
			</div>
		</div>

		<div class="row">
			<div class="col-md-6 col-sm-6 col-xs-12" v-for="good in itemsToShow" style="visibility: hidden" :style="{visibility: 'visible'}">
				<div class="good-container">
					<div class="row flex">
						<div class="col-lg-6 col-md-12 col-sm-12 col-xs-12">
							<div class="good-picture" :style="{'background-image': good.Images.length ? 'url('+good.ImagesUrl + good.Images[0]+')' : ''}"></div>
						</div>
						<div class="col-lg-6 col-md-12 col-sm-12 col-xs-12 good-info">
							<h4>
								{{good.Title}}
							</h4>

							<div class="info">
								<small class="glyphicon glyphicon-star"></small> {{good.Brand}} {{good.Model}}
								<br>
								<template v-if="good.Home">
									<small class="glyphicon glyphicon-globe"></small> {{good.Home}}
								</template>
								<template v-else>&nbsp;</template>
							</div>

							<br>

							<div class="actions row">
								<div class="col-xs-12">
									<div class="btn btn-sm btn-block btn-info" v-on:click="selectGood(good)">
										<span class="glyphicon glyphicon-bookmark"></span>
										Ver detalhes/Reservar
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>

		<div class="text-center">
			<pager ref="pager" :max-pages="10" :page-count="pageCount" :current-page="currentPage" v-on:change="pageChange"></pager>
		</div>
	</pane>

	<pane ref="details" :expanded="false">
		<template v-if="selectedGood">
			<h3>Detalhes de {{selectedGood.Code}}</h3>


			<div class="row good-large">
				<div class="col-lg-6 col-md-12 col-sm-12 col-xs-12">
					<div class="good-picture" :style="{'background-image': selectedGood.Images.length ? 'url('+selectedGood.ImagesUrl + selectedGood.Images[0]+')' : ''}">
						<div class="btn btn-primary" v-on:click="slideshowOpen" v-if="selectedGood.Images.length > 1">
							<span class="glyphicon glyphicon-camera"></span> + {{selectedGood.Images.length-1}}
						</div>
					</div>
				</div>
				<div class="col-lg-6 col-md-12 col-sm-12 col-xs-12 good-info">
					<h3>
						{{selectedGood.Title}}
					</h3>

					<div class="info">
						<div class="info-item no-select" v-popover.top.body.hover="'Nome do bem'">
							<small class="glyphicon glyphicon-star"></small> {{selectedGood.Brand}} {{selectedGood.Model}}
						</div>

						<div class="row">
							<div class="col-sm-6 col-xs-12">
								<div class="info-item no-select" v-popover.top.body.hover="'Localização'" v-if="selectedGood.Home">
									<small class="glyphicon glyphicon-globe"></small> {{selectedGood.Home}}
								</div>

								<div class="info-item no-select" v-popover.top.body.hover="'Capacidade'" v-if="selectedGood.Capacity">
									<small class="glyphicon glyphicon-user"></small> {{selectedGood.Capacity}} pessoa{{selectedGood.Capacity > 1 ? 's' : ''}}
								</div>
							</div>
							<div class="col-sm-6 col-xs-12">
								<div class="info-item no-select" v-popover.top.body.hover="'Carga máxima'" v-if="selectedGood.CarryCapacity">
									<small class="glyphicon glyphicon-briefcase"></small> Máximo de {{selectedGood.CarryCapacity}} kg
								</div>

								<div class="info-item no-select" v-popover.top.body.hover="'Custo'" v-if="selectedGood.DefaultCost || (selectedGood.DefaultCost && selectedGood.VariableCostMeasurement)">
									<small class="glyphicon glyphicon-usd"></small> {{selectedGood.DefaultCost}} pontos
									<span v-if="selectedGood.VariableCost">+ {{selectedGood.DefaultCost}} pontos/{{measurements._strings[selectedGood.VariableCostMeasurement]}}</span>
								</div>
							</div>
						</div>

						<div class="info-item no-select" v-popover.top.body.hover="'Descrição'" v-if="selectedGood.Description">
							<small class="glyphicon glyphicon-book"></small> {{selectedGood.Description}}
						</div>

						<div class="info-item no-select" v-popover.top.body.hover="'Observações'" v-if="selectedGood.Observations">
							<small class="glyphicon glyphicon-eye-open"></small> {{selectedGood.Observations}}
						</div>
					</div>


					<template v-if="selectedGood.DefaultCost || (selectedGood.DefaultCost && selectedGood.VariableCostMeasurement)">
						<h3>Reservar:</h3>

						<reservation-edit v-model="reservation"></reservation-edit>

						<h4 class="text-right">
							A partir de {{reservation.calculateCost()}} pontos
						</h4>

						<br>
						<div class="btn btn-block btn-info" v-on:click="book(selectedGood)">
							<span class="glyphicon glyphicon-bookmark"></span>
							Reservar
						</div>
					</template>
				</div>
			</div>


			<div class="row" style="margin-top: 25px">
				<div class="col-sm-3 col-xs-6">
					<div class="btn btn-block btn-warning" v-on:click="showList">
						<span class="glyphicon glyphicon-chevron-left"></span>
						Voltar
					</div>
				</div>
				<div class="col-sm-6 hidden-xs"></div>
				<div class="col-sm-3 col-xs-6">
				</div>
			</div>
		</template>
	</pane>
</div>

<style>
	.good-container {
		margin-bottom: 15px;
		background: linear-gradient(45deg, rgba(121, 139, 189, 0.59) 0%, rgba(57, 51, 90, 0.77) 90%);
	}

	.good-picture {
		background-position: center center;
		background-size: cover;
		position: relative;
		height: 100%;
		min-height: 250px;
	}
	.good-picture .btn {
		position: absolute;
		right: 0;
		top: 0;
	}

	.good-info {
		padding: 25px;
		height: 250px;
	}
	.good-info .info {
		font-size: .9em;
	}
	.info .info-item {
		padding: 10px;
		transition: all .5s;
		background: rgba(255, 255, 255, 0);
	}
	.info .info-item:hover {
		background: rgba(255, 255, 255, .2);
	}
	.info .info-item .glyphicon {
		margin-right: 10px;
	}

	.good-info .actions {
		position: absolute;
		left: 25px;
		right: 35px;
		bottom: 20px;
	}

	.good-large .good-picture {
		min-height: 450px;
		position: relative;
	}
	.good-large .good-info {
		padding: 0 25px;
		height: auto !important;
	}
	.good-large .good-info .info {
		font-size: 1.2em;
	}

	@media (max-width: 1200px) {
		.good-container {
			padding-bottom: 15px;
		}
		.good-picture {
			height: 400px;
			text-align: center;
		}
		.good-picture img {
			height: 100%;
		}
		.good-info {
			margin-top: -78px;
			height: 220px;
		}
		.good-large .good-info {
			margin-top: -51px;
		}
		.good-info h4, .good-info h3 {
			margin-bottom: .5em;
			text-shadow: 0 0 15px rgba(0,0,0,1);
		}
		.good-info h4 {
			font-size: 2em;
		}
	}
	@media (max-width: 992px) {
		.good-picture {
			height: 300px;
			text-align: center;
		}
	}

</style>


<?PHP
$types = GoodType::Select();
$goods = Good::Select(['Hidden'=>0], 'TypeId ASC');
?>

<script type="application/json" id="types-json" ><?=json_encode(BaseModel::SerializeArray($types))?></script>
<script type="application/json" id="goods-json" ><?=json_encode(BaseModel::SerializeArray($goods))?></script>

<?=VueParser::Inline('entity/ReservationEdit')?>
<?=ScriptDependency::Current()->IncludeScript('entities/Good')?>
<?=ScriptDependency::Current()->IncludeScript('entities/Reservation')?>
<?=ScriptDependency::Current()->IncludeScript('Components/slideshow')?>
<?=ScriptDependency::Current()->IncludeScript('Components/Map')?>

<script>
	var goodTypes = InlineJsonToEntityList('types');
	var goods = InlineJsonToEntityList('goods');

	var urlGoodId = <?=$_GET['good'] | 0?>;


	var mainVM = new Vue({
		el: '#main',
		data: {
			goods: goods,
			types: goodTypes,
			itemsPerPage: 6,
			currentPage: 1,
			selectedType: null,
			selectedGood: null,
			slideshow: new SlideShow(),
			measurements: Good.UsageMeasurement,

			reservation: new Reservation()
		},
		computed: {
			pageCount: function () {
				return Math.ceil(this.filteredItems.length / this.itemsPerPage);
			},
			filteredItems: function () {
				var vm = this;
				return this.selectedType === null ? this.goods : this.goods.filter(function (e) {
					return e.TypeId === vm.selectedType.Id;
				});
			},
			itemsToShow: function () {
				var start = (this.currentPage-1) * this.itemsPerPage;
				var end = start + this.itemsPerPage;

				return this.filteredItems.slice(start,end)
			},
			slideShowImages: function () {
				var r = [];

				if (this.selectedGood) {
					for (var i = 0; i < this.selectedGood.Images.length; i++) {
						r.push(new SlideShowImage(this.selectedGood.ImagesUrl + this.selectedGood.Images[i], ''));
					}
				}

				return r;
			}
		},
		watch: {
		},
		methods: {
			pageChange: function (p) {
				this.currentPage = p;
				$(window).scrollTop(0);
			},
			selectType: function (type) {
				this.$refs.pager.changePage(1);
				this.selectedType = type;
			},
			showList: function () {
				this.$refs.list.show();

				this.$refs.details.hideNext();
			},
			selectGood: function (good) {
				this.selectedGood = good;

				this.reservation = new Reservation({
					Good: good.Serialize()
				});

				this.$refs.details.showNext();
				this.$refs.list.hideNext();
			},
			book: function (good) {
				Loading.Show('Solicitando reserva...');

				Session.Do('Reservation', 'Create',{
					object: JSON.stringify(this.reservation.Serialize())
				}, function (result) {
					Loading.Hide();
					if (result){
						toast('success', 'Reserva solicitada!', 'Sucesso', 15000)
					}
				});
			},
			slideshowOpen: function () {
				if (this.slideShowImages.length){
					this.slideshow.SetImages(this.slideShowImages);
					this.slideshow.Open(0);
				}
			}
		},
		mounted: function () {
		    if (urlGoodId){
		        let good = this.goods.filter(x => x.Id === urlGoodId);
		        if (good.length){
		            good = good[0];
		            this.selectGood(good);
                }
            }
		}
	});
</script>
