<?php

function CSV(){
	Good::GetDataAccess()->CreateTable(true);

	$reader = new CSVParser(GetDynamicDirectory().'item.csv', ',');

	/** @var GoodType[] $goodTypes */
	$goodTypes = GoodType::Select();

	$typesHashTable = [
		'Avião'=>'Avião',
		'Helicoptero'=>'Helicóptero',
		'Carro'=>'Veículo',
		'Barco'=>'Barco',
		'Casa'=>'Casa'
	];


	$reader->Parse(function ($data) use($goodTypes, $typesHashTable) {
		print_r($data);

		$t = array_filter($goodTypes, function ($e) use ($data, $typesHashTable){
			return $e->Name == $typesHashTable[$data['bem_tipo']];
		});

		if (!count($t)){
			echo 'failed to find type: '.$data['bem_tipo'];
			return;
		}else{
			$t = $t[array_keys($t)[0]];
		}

		$good = new Good();
		$good->Code = $data['bem_cod'];
		$good->Type = $t;
		$good->Title = $data['bem_titulo'];
		$good->Brand = $data['bem_marca'];
		$good->Model = $data['bem_modelo'];
		$good->Description = $data['bem_descricao'];
		$good->Capacity = $data['bem_pax'];

		$good->CarryCapacity = $data['bem_carga'];
		$good->DefaultCost = $data['bem_pontosf'];
		$good->DefaultCostMeasurement = $data['bem_pontosf_un'];
		$good->VariableCost = $data['bem_pontosv'];
		$good->VariableCostMeasurement = $data['bem_pontosv_un'];
		$good->Observations = $data['bem_obs'];
		$good->Home = $data['bem_home'];
		$good->PlansAllowed = $data['bem_classe'];

		$good->SaveAndSetId();

		print_r($good->Serialize());
	});
}