<div id="menu" class="start-hidden">
	<div class="links text-josefin">
		<a href="/">&lt; Voltar</a>
	</div>
</div>

<div class="container-fluid slide full-screen" id="main" style="color: white;">
	<div class="bg" style="background-image: url(/static/images/bg-sober.jpg)"></div>

	<div class="text-container" style="margin: 0; padding: 50px">
		<h1 class="text-center">Bens</h1>
		<h4 class="text-center">Veja aqui todas os bens que os membros do Ultra podem usufruir.</h4>
	</div>

    <pane ref="list" class="container">
        <div class="text-center" style="margin-bottom: 15px; visibility: hidden" :style="{visibility: 'visible'}">
            <div class="btn-group">
                <button class="btn" :class="selectedType === null ? 'btn-primary' : 'btn-default'" v-on:click="selectType(null)">Todos</button>
                <button class="btn" :class="selectedType === type ? 'btn-primary' : 'btn-default'" v-for="type in types"
                        v-on:click="selectType(type)">{{type.NamePlural}}</button>
            </div>
        </div>

        <div class="row">
            <div class="col-md-6 col-sm-6 col-xs-12" v-for="good in itemsToShow" style="visibility: hidden" :style="{visibility: 'visible'}">
                <div class="good-container">
                    <div class="row flex">
                        <div class="col-lg-6 col-md-12 col-sm-12 col-xs-12">
                            <div class="good-picture" :style="{'background-image': good.Images.length ? 'url('+good.ImagesUrl + good.Images[0]+')' : ''}"></div>
                        </div>
                        <div class="col-lg-6 col-md-12 col-sm-12 col-xs-12 good-info">
                            <h4>
                                {{good.Title}}
                            </h4>

                            <div class="info">
                                <small class="glyphicon glyphicon-star"></small> {{good.Brand}} {{good.Model}}
                                <br>
                                <template v-if="good.Home">
                                    <small class="glyphicon glyphicon-globe"></small> {{good.Home}}
                                </template>
                                <template v-else>&nbsp;</template>
                            </div>

                            <br>

                            <div class="actions row">
                                <div class="col-xs-12">
                                    <div class="btn btn-sm btn-block btn-info" v-on:click="selectGood(good)">
                                        <span class="glyphicon glyphicon-bookmark"></span>
                                        Ver detalhes/Reservar
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div class="text-center">
            <pager ref="pager" :max-pages="10" :page-count="pageCount" :current-page="currentPage" v-on:change="pageChange"></pager>
        </div>

        <br>
    </pane>


    <pane ref="details" class="container" :expanded="false">
        <template v-if="selectedGood">
            <h3>Detalhes de {{selectedGood.Code}}</h3>


            <div class="row good-large">
                <div class="col-lg-6 col-md-12 col-sm-12 col-xs-12">
                    <div class="good-picture" :style="{'background-image': selectedGood.Images.length ? 'url('+selectedGood.ImagesUrl + selectedGood.Images[0]+')' : ''}">
                        <div class="btn btn-primary" v-on:click="slideshowOpen" v-if="selectedGood.Images.length > 1">
                            <span class="glyphicon glyphicon-camera"></span> + {{selectedGood.Images.length-1}}
                        </div>
                    </div>
                </div>
                <div class="col-lg-6 col-md-12 col-sm-12 col-xs-12 good-info">
                    <h3>
                        {{selectedGood.Title}}
                    </h3>

                    <div class="info">
                        <div class="info-item no-select" v-popover.top.body.hover="'Nome do bem'">
                            <small class="glyphicon glyphicon-star"></small> {{selectedGood.Brand}} {{selectedGood.Model}}
                        </div>

                        <div class="row">
                            <div class="col-sm-6 col-xs-12">
                                <div class="info-item no-select" v-popover.top.body.hover="'Localização'" v-if="selectedGood.Home">
                                    <small class="glyphicon glyphicon-globe"></small> {{selectedGood.Home}}
                                </div>

                                <div class="info-item no-select" v-popover.top.body.hover="'Capacidade'" v-if="selectedGood.Capacity">
                                    <small class="glyphicon glyphicon-user"></small> {{selectedGood.Capacity}} pessoa{{selectedGood.Capacity > 1 ? 's' : ''}}
                                </div>
                            </div>
                            <div class="col-sm-6 col-xs-12">
                                <div class="info-item no-select" v-popover.top.body.hover="'Carga máxima'" v-if="selectedGood.CarryCapacity">
                                    <small class="glyphicon glyphicon-briefcase"></small> Máximo de {{selectedGood.CarryCapacity}} kg
                                </div>

                                <div class="info-item no-select" v-popover.top.body.hover="'Custo'" v-if="selectedGood.DefaultCost || (selectedGood.DefaultCost && selectedGood.VariableCostMeasurement)">
                                    <small class="glyphicon glyphicon-usd"></small> {{selectedGood.DefaultCost}} pontos
                                    <span v-if="selectedGood.VariableCost">+ {{selectedGood.DefaultCost}} pontos/{{measurements._strings[selectedGood.VariableCostMeasurement]}}</span>
                                </div>
                            </div>
                        </div>

                        <div class="info-item no-select" v-popover.top.body.hover="'Descrição'" v-if="selectedGood.Description">
                            <small class="glyphicon glyphicon-book"></small> {{selectedGood.Description}}
                        </div>

                        <div class="info-item no-select" v-popover.top.body.hover="'Observações'" v-if="selectedGood.Observations">
                            <small class="glyphicon glyphicon-eye-open"></small> {{selectedGood.Observations}}
                        </div>
                    </div>


                    <template>
                        <h3>Para reservar...</h3>
                        <br>
                        <div class="auth row">
                            <div class="col-xs-6">
                                <a :href="'<?=GetProjectUrl('Search', '', 'app')?>?good='+selectedGood.Id" class="btn btn-block btn-lg btn-success" style="margin-bottom: 10px">
                                    Faça login
                                </a>
                            </div>
                            <div class="col-xs-6">
                                <a href="/Register/" class="btn btn-block btn-lg btn-primary">
                                    Ou associe-se!
                                </a>
                            </div>
                        </div>
                    </template>
                </div>
            </div>


            <div class="row" style="margin-top: 25px">
                <div class="col-sm-3 col-xs-6">
                    <div class="btn btn-block btn-warning" v-on:click="showList">
                        <span class="glyphicon glyphicon-chevron-left"></span>
                        Voltar
                    </div>
                </div>
                <div class="col-sm-6 hidden-xs"></div>
                <div class="col-sm-3 col-xs-6">
                </div>
            </div>
        </template>
    </pane>
</div>

<?=ScriptDependency::Current()->IncludeScript('Loading')?>
<?=ScriptDependency::Current()->IncludeScript('entities/Good')?>
<?=ScriptDependency::Current()->IncludeScript('entities/Reservation')?>
<?=ScriptDependency::Current()->IncludeScript('Components/slideshow')?>
<?=ScriptDependency::Current()->IncludeScript('Components/Map')?>
<?=ScriptDependency::Current()->IncludeScript('libs/vue-2.1.3')?>
<?=VueParser::Inline('Pane')?>
<?=VueParser::Inline('Pager')?>
<?=VueParser::Inline('PagedTable')?>

<?PHP
$types = GoodType::Select();
$goods = Good::Select(['Hidden'=>0], 'TypeId ASC');
?>

<script type="application/json" id="types-json" ><?=json_encode(BaseModel::SerializeArray($types))?></script>
<script type="application/json" id="goods-json" ><?=json_encode(BaseModel::SerializeArray($goods))?></script>

<script>
    var goodTypes = InlineJsonToEntityList('types');
    var goods = InlineJsonToEntityList('goods');

	var mainVM = new Vue({
		el: '#main',
		data: {
			types: goodTypes,
            goods: goods,
            itemsPerPage: 6,
            currentPage: 1,
            selectedType: null,
            selectedGood: null,
            slideshow: new SlideShow(),
            measurements: Good.UsageMeasurement,

            reservation: new Reservation(),

            typeKeys: {
                car: 1,
                helicopter: 3,
                plane: 2,
                house: 5,
                boat: 4
            }
		},
        computed: {
            pageCount: function () {
                return Math.ceil(this.filteredItems.length / this.itemsPerPage);
            },
            filteredItems: function () {
                var vm = this;
                return this.selectedType === null ? this.goods : this.goods.filter(function (e) {
                    return e.TypeId === vm.selectedType.Id;
                });
            },
            itemsToShow: function () {
                var start = (this.currentPage-1) * this.itemsPerPage;
                var end = start + this.itemsPerPage;

                return this.filteredItems.slice(start,end)
            },
            slideShowImages: function () {
                var r = [];

                if (this.selectedGood) {
                    for (var i = 0; i < this.selectedGood.Images.length; i++) {
                        r.push(new SlideShowImage(this.selectedGood.ImagesUrl + this.selectedGood.Images[i], ''));
                    }
                }

                return r;
            }
        },
        methods: {
            pageChange: function (p) {
                this.currentPage = p;
                $(window).scrollTop(0);
            },
            selectType: function (type) {
                this.$refs.pager.changePage(1);
                this.selectedType = type;
            },
            showList: function () {
                this.$refs.list.show();

                this.$refs.details.hideNext();
            },
            selectGood: function (good) {
                this.selectedGood = good;

                this.reservation = new Reservation({
                    Good: good.Serialize()
                });

                this.$refs.details.showNext();
                this.$refs.list.hideNext();
            },
            book: function (good) {
                Loading.Show('Solicitando reserva...');

                Session.Do('Reservation', 'Create',{
                    object: JSON.stringify(this.reservation.Serialize())
                }, function (result) {
                    Loading.Hide();
                    if (result){
                        toast('success', 'Reserva solicitada!', 'Sucesso', 15000)
                    }
                });
            },
            slideshowOpen: function () {
                if (this.slideShowImages.length){
                    this.slideshow.SetImages(this.slideShowImages);
                    this.slideshow.Open(0);
                }
            }
        },
        mounted: function () {
            var hash = window.location.hash.toString().replace("#", "");
            if (this.typeKeys[hash]){
                var id = this.typeKeys[hash];

                this.selectedType = this.types.filter(function (e) {
                    return e.Id == id;
                })[0];
            }
        }
	});

	var slideshow = new SlideShow();
</script>
<?=ScriptDependency::Current()->IncludeScript('Menu')?>