<?PHP
$user = User::LoggedUser();
if (!$user){
	$user = new User();
	$user->Password = '';
}

$user->ReceiveEmailMarketing = true;
$user->Password = '';

if (!$user->Birthday) $user->Birthday = null;
if (!$user->Address) $user->Address = new Address();
?>

<div class="container-fluid slide fixed full-screen no-select" id="register" style="min-height: 100vh">
	<div class="bg fixed" style="background-image: url(/static/images/bg-sober.jpg)"></div>
	<div class="text-container" style="background: rgba(30, 30, 30, .8); color: white;">
		<div class="container" style="padding: 50px 35px; display: none" :style="{display: ''}">
			<pane ref="formPane">
				<div class="circle pull-right" style="width: 100px; height: 100px;" v-if="user.HasAvatar">
					<img :src="user.avatarUrl()" alt="">
				</div>
				<h2 class="text-center">Cadastro</h2>
				<p v-if="user.Id">Olá {{user.DisplayName}}!</p>
				<p>Bem vindo ao Ultra, para começar precisaremos coletar algumas informações básicas:</p>

				<div class="row">
					<div class="col-md-12">
						<div class="form-group" :class="{'has-success': isFullNameValid}">
							<label>
								Nome completo
							</label>
							<input type="text" class="form-control" v-model="user.FullName"
							       v-popover.top.focus="'Seu nome completo, precisamos dessa informação para fins legais e para poder garantir a segurança de nossos membros.'">
						</div>
					</div>
				</div>

				<div class="row">
					<div class="col-sm-6">
						<div class="form-group" :class="{'has-success': isNameValid}">
							<label>
								Nome de exibição
							</label>
							<input type="text" class="form-control" v-model="user.DisplayName"
							       v-popover.top.focus="'Como você deseja ser chamado, será o nome que será exibido ao usar o site.'">
						</div>
					</div>

					<div class="col-sm-6">
						<div class="form-group" :class="{'has-success': isEmailValid}">
							<label>Email</label>
							<input type="email" class="form-control" v-model="user.Email">
						</div>
					</div>
				</div>

				<div class="row">
					<div class="col-xs-6">
						<div class="form-group" :class="{'has-success': isCpfValid, 'has-error': !isCpfValid && user.CPF.length >= 11}">
							<label>
								CPF
							</label>
							<input type="tel" class="form-control" v-model="user.CPF"
							       v-popover.top.focus="'Essa informação jamais será tornada pública, ela serve para fins legais e para garantir a segurança de nossos membros.'">
						</div>
					</div>

					<div class="col-xs-6">
						<div class="form-group" :class="{'has-success': isTelephoneValid, 'has-error': !isTelephoneValid && user.Telephone.length >= 11}">
							<label>Telefone</label>
							<input type="tel" class="form-control" v-model="user.Telephone" placeholder="Inclua o ddd e ddi se necessário">
						</div>
					</div>
				</div>

				<div class="row">
					<div class="col-xs-6">
						<div class="form-group" :class="user.Birthday ? (user.age() >= 18 ? 'has-success' : 'has-error') : ''">
							<label>
								Nascimento
							</label>
							<input type="date" class="form-control" name="birthday" id="birthday" placeholder="Nascimento" required v-model="birthday"
							       v-popover.top.focus="user.Birthday && user.age() < 18 ? 'Você deve ser maior de idade' : ''">
						</div>
					</div>

					<div class="col-xs-6">
						<div class="form-group" :class="{'has-success': user.Gender}">
							<label>Gênero</label>
							<select class="form-control" v-model="user.Gender">
								<option value="">Escolha...</option>
								<option value="1">Masculino</option>
								<option value="2">Feminino</option>
								<option value="3">Não binário</option>
								<option value="4">Prefiro Não informar</option>
							</select>
						</div>
					</div>
				</div>

				<div class="row">
					<div class="col-xs-6">
						<div class="form-group" :class="user.Password ? 'has-success' : ''">
							<label>Senha</label>
							<input type="password" class="form-control" v-model="user.Password">
						</div>
					</div>
					<div class="col-xs-6">
						<div class="form-group" :class="passwordConfirm ? (user.Password == passwordConfirm ? 'has-success' : 'has-error') : ''">
							<label>Confirme a senha</label>
							<input type="password" class="form-control" v-model="passwordConfirm"
							       v-popover.top.focus="user.Password != passwordConfirm && passwordConfirm ? 'As senhas não conferem' : ''">
						</div>
					</div>
				</div>

				<div class="row">
					<div class="col-md-12">
						<div class="form-group" :class="user.Password ? 'has-success' : ''">
							<label>Endereço</label>
						</div>
					</div>
				</div>

				<div class="row">
					<div class="col-xs-7">
						<div class="form-group" :class="user.Address.Street.length >=4 ? 'has-success' : ''">
							<label>Rua</label>
							<input type="text" class="form-control" v-model="user.Address.Street">
						</div>
					</div>
					<div class="col-xs-2">
						<div class="form-group" :class="user.Address.Number ? 'has-success' : ''">
							<label>N<sup>o</sup></label>
							<input type="text" class="form-control" v-model="user.Address.Number">
						</div>
					</div>
					<div class="col-xs-3">
						<div class="form-group" :class="user.Address.NumberComplement ? 'has-success' : ''">
							<label>Comp.</label>
							<input type="text" class="form-control" v-model="user.Address.NumberComplement" placeholder="bloco, ap, ...">
						</div>
					</div>
				</div>

				<div class="row">
					<div class="col-xs-8">
						<div class="form-group" :class="user.Address.Neighborhood.length >=2 ? 'has-success' : ''">
							<label>Bairro</label>
							<input type="text" class="form-control" v-model="user.Address.Neighborhood">
						</div>
					</div>
					<div class="col-xs-4">
						<div class="form-group" :class="isPostalCodeValid ? 'has-success' : ''">
							<label>CEP</label>
							<input type="text" class="form-control" v-model="user.Address.PostalCode">
						</div>
					</div>
				</div>

				<div class="row">
					<div class="col-xs-8">
						<div class="form-group" :class="user.Address.City.length >= 2 ? 'has-success' : ''">
							<label>Cidade</label>
							<input type="text" class="form-control" v-model="user.Address.City">
						</div>
					</div>
					<div class="col-xs-4">
						<div class="form-group" :class="user.Address.State.length==2 ? 'has-success' : ''">
							<label>Estado</label>
							<input type="text" class="form-control" v-model="user.Address.State" maxlength="2">
						</div>
					</div>
				</div>


				<div class="row">
					<div class="col-md-12 text-center">
						<label style="color: #aaa; font-weight: normal">
							<input type="checkbox" v-model="user.ReceiveEmailMarketing" />
							Aceito receber emails da Ultra e de seus parceiros.
							<span></span>
						</label>
					</div>
				</div>

				<div class="row">
					<div class="col-md-12">
						<div class="form-group">
							<button class="form-control" v-on:click="register"
								:style="{opacity: isRegistrationValid ? 1 : .1}">
								Cadastrar
							</button>
						</div>

						<div class="text-center" style="font-size: .8em">
							Ao se cadastrar você afirma aceitar os presentes <a href="/dynamic/TOS.html" target="_blank">Termos de Uso</a>.
						</div>
					</div>
				</div>
			</pane>
			<pane ref="successPane" :expanded="false">
				<h2 class="text-center">Sucesso!</h2>
				<p>
					Enviamos um email para o endereço fornecido para que você confirme sua conta, após isso um de nossos
					representantes entrará em contato com você para dar prosseguimento à sua aprovação como sócio.
				</p>

				<p>
					Caso ainda tenha alguma dúvida fique a vontade para entrar em contato através de <a href="mailto:contato@ultraclub.club" style="color: white; font-weight: bold;">contato@ultraclub.club</a>.
				</p>
			</pane>
		</div>
	</div>
</div>

<?=VueParser::Inline('Pane')?>
<?=ScriptDependency::Current()->IncludeScript('entities/User')?>
<?=ScriptDependency::Current()->IncludeScript('Loading')?>
<script type="application/json" id="user-json"><?=json_encode($user->Serialize())?></script>
<script>
	var registrationVM = new Vue({
		el: '#register',
		data: {
			user: InlineJsonToEntity('user'),
			passwordConfirm: ''
		},
		computed: {
			isFullNameValid: function () {
				return this.user.FullName.length >= 10
			},
			isNameValid: function () {
				return this.user.DisplayName.length >= 3
			},
			isEmailValid: function () {
				return this.user.isEmailValid()
			},
			isEmailInvalid: function () {
				return this.user.Email.length >=10 && !this.user.isEmailValid()
			},
			isCpfValid: function () {
				if (!this.user.CPF) this.user.CPF = '';

				var str = this.user.CPF.replace(/[^0-9]/gi, "");

				if (str.length > 11){
					str = str.substr(0,11);
				}

				if (str.length != 11){
					return false;
				}

				str = str.substr(0,3) + "." + str.substr(3,3) + "." + str.substr(6,3) + "-" + str.substr(9,2);

				if (this.user.CPF != str){
					this.user.CPF = str;
				}

				return this.user.isCpfValid();
			},
			isTelephoneValid: function () {
				if (!this.user.Telephone) this.user.Telephone = '';

				var str = this.user.Telephone.replace(/[^0-9]/gi, "");

				if (str.length == 14){
					// 999 99 99999-9999
					str = "+" + str.substr(0,3) + " " + str.substr(3,2) + " " + str.substr(5,5) + "-" + str.substr(10,4);

				}else if (str.length == 13){
					// 99 99 99999-9999
					str = "+" + str.substr(0,2) + " " + str.substr(2,2) + " " + str.substr(4,5) + "-" + str.substr(9,4);

				}else if (str.length == 11){
					// 99 99999-9999
					str = str.substr(0,2) + " " + str.substr(2,5) + "-" + str.substr(7,4);

				}else if (str.length == 10){
					// 99 9999-9999
					str = str.substr(0,2) + " " + str.substr(2,4) + "-" + str.substr(6,4);

				}else{
					return false;
				}

				if (this.user.Telephone != str){
					this.user.Telephone = str;
				}

				return true;
			},
			isPostalCodeValid: function () {
				if (!this.user.Address.PostalCode) this.user.Address.PostalCode = '';

				var str = this.user.Address.PostalCode.replace(/[^0-9]/gi, "");

				if (str.length == 8){
					str = str.substr(0,5) + "-" + str.substr(5,3);
				}else{
					return false;
				}

				if (this.user.Address.PostalCode != str){
					this.user.Address.PostalCode = str;
				}

				return true;
			},
			isAddressValid: function () {
				return this.user.Address.PostalCode.length == 9 &&
					this.user.Address.Street.length >= 4 &&
					this.user.Address.Number.length &&
					this.user.Address.Neighborhood.length >= 2 &&
					this.user.Address.City.length >= 2 &&
					this.user.Address.State.length == 2
			},

			isRegistrationValid: function () {
				return this.isFullNameValid &&
					this.isNameValid &&
					this.isEmailValid &&
					this.isCpfValid &&
					this.isTelephoneValid &&
					this.user.Gender &&
					this.user.Password &&
					this.user.Password == this.passwordConfirm &&
					this.user.age() >= 18 &&
					this.isAddressValid
			},

			birthday: {
				cache: false,
				get: function () {
					return this.user.Birthday ? this.user.Birthday.format('Y-m-d') : '';
				},
				set: function (value) {
					value = value.split('-');

					var year = parseInt(value[0]);
					var month = parseInt(value[1])-1;
					var day = parseInt(value[2]);

					if (year > 1900 && month >= 0 && day > 0){
						if (!this.user.Birthday){
							this.user.Birthday = new Date();
							this.user.Birthday.setHours(0);
							this.user.Birthday.setMinutes(0);
							this.user.Birthday.setSeconds(0);
							this.user.Birthday.setMilliseconds(0);
						}

						this.user.Birthday.setYear(year);
						this.user.Birthday.setMonth(month);
						this.user.Birthday.setDate(day);

						this.user.Birthday = new Date(this.user.Birthday.getTime());
					}else{
						this.user.Birthday = null;
					}
				}
			},
		},
		methods: {
			register: function () {
				var vm = this;

				if (this.isRegistrationValid){
					Loading.Show();
					
					Session.Do('Register', 'Register', { user: JSON.stringify(this.user.Serialize()) }, function (data) {
						Loading.Hide();
						if (data.Id){
							vm.$refs.formPane.hide();
							vm.$refs.successPane.show();
						}else{
							alert('Houve um erro.');
						}
					})
				}
			}
		}
	});
</script>