<?php
/**
 * Created by PhpStorm.
 * User: Daniel
 * Date: 20/02/2017
 * Time: 00:16
 */



function Approve(){
    $reservation = new Reservation($_POST['id']);

    $bo = $reservation->Renter->BalanceOperation(
        -$reservation->getCost(),
        'Reserva #'.str_pad($reservation->Id, 5, '0',STR_PAD_LEFT)
    );

    if ($bo->Id){
        $reservation->LoadRelationships(true);
        $reservation->Status = ReservationStatus::Approved;
        $reservation->Save();
    }

    // Email status update to client
    $reservation->Renter->SendMail('A reserva #'.$reservation->Id.' foi aprovada!',
        EmailTemplate::RenderContent('ReservationUpdated.html', ['user'=>$reservation->Renter, 'reservation'=>$reservation], 'app'),
        'ultra-reservation-approve');

    return $reservation->Serialize();
}

function Deny(){
    $reservation = new Reservation($_POST['id']);

    $reservation->LoadRelationships(true);
    $reservation->Status = ReservationStatus::Denied;
    $reservation->Save();

    // Email status update to client
    $reservation->Renter->SendMail('A reserva #'.$reservation->Id.' foi negada.',
        EmailTemplate::RenderContent('ReservationUpdated.html', ['user'=>$reservation->Renter, 'reservation'=>$reservation], 'app'),
        'ultra-reservation-deny');

    return $reservation->Serialize();
}

function Cancel(){
	$reservation = new Reservation($_POST['id']);

	$bo = $reservation->Renter->BalanceOperation(
		$reservation->getCost(),
		'Estorno: Reserva #'.str_pad($reservation->Id, 5, '0',STR_PAD_LEFT)
	);

	if ($bo->Id){
		$reservation->LoadRelationships(true);
		$reservation->Status = ReservationStatus::Canceled;
		$reservation->Save();
	}

    // Email status update to client
    $reservation->Renter->SendMail('A reserva #'.$reservation->Id.' foi cancelada.',
        EmailTemplate::RenderContent('ReservationUpdated.html', ['user'=>$reservation->Renter, 'reservation'=>$reservation], 'app'),
        'ultra-reservation-cancel');

	return $reservation->Serialize();
}

function Start(){
	$reservation = new Reservation($_POST['id']);

	if ($reservation->Status == ReservationStatus::Approved){
		$reservation->Status = ReservationStatus::Started;
		$reservation->CheckInTime = time();
		$reservation->Save();

        // Email status update to client
        $reservation->Renter->SendMail('A reserva #'.$reservation->Id.' foi inciada!',
            EmailTemplate::RenderContent('ReservationUpdated.html', ['user'=>$reservation->Renter, 'reservation'=>$reservation], 'app'),
            'ultra-reservation-start');

		return $reservation->Serialize();
	}
	return null;
}

function Finish(){
	$reservation = new Reservation($_POST['id']);

	if ($reservation->Status == ReservationStatus::Started){

		if ($reservation->ExtraCredits){
			$bo = $reservation->Renter->BalanceOperation(
				-$reservation->ExtraCredits,
				'Custo extra - Reserva #'.str_pad($reservation->Id, 5, '0',STR_PAD_LEFT)
			);

			if (!$bo){
				throw new Exception("Couldn't charge.");
			}

			$reservation->LoadRelationships(true);
		}

		$reservation->Status = ReservationStatus::Finished;
		$reservation->CheckOutTime = time();
		$reservation->Save();

        // Email status update to client
        $reservation->Renter->SendMail('A reserva #'.$reservation->Id.' foi finalizada!',
            EmailTemplate::RenderContent('ReservationUpdated.html', ['user'=>$reservation->Renter, 'reservation'=>$reservation], 'app'),
            'ultra-reservation-end');

		return $reservation->Serialize();
	}
	return null;
}