<!DOCTYPE html>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
        <title>[Panel] Ultra Club</title>

	    <?=ScriptDependency::Current()->IncludeScript('General')?>
	    <?=ScriptDependency::Current()->IncludeScript('Date')?>
	    <?=ScriptDependency::Current()->IncludeScript('Session')?>
	    <?=ScriptDependency::Current()->IncludeScript('libs/vue-2.1.3')?>
	    <?=ScriptDependency::Current()->IncludeScript('Bootsvue')?>
	    <?=ScriptDependency::Current()->IncludeScript('Loading')?>
	    <?=ScriptDependency::Current()->IncludeScript('orm/Entity')?>
	    <?=ScriptDependency::Current()->IncludeScript('entities/User')?>

	    <link href="https://fonts.googleapis.com/css?family=Josefin+Sans:400,700|Titillium+Web:400,400i,700" rel="stylesheet">

	    <link rel="stylesheet" type="text/css" href="/static/css/Main.css"/>
	    <link rel="stylesheet" type="text/css" href="/static/css/Layout.css"/>

	    <meta name="viewport" content="width=420, user-scalable=no">

	    <link id="favicon" rel="shortcut icon" href="/static/images/favicon_red<?=$settings::$Environment === 'local' ? '_local':''?>.png" type="image/png" />

	    <script type="text/javascript" src="/static/js/libs/toastr/toastr.min.js"></script>
	    <link rel="stylesheet" type="text/css" href="/static/js/libs/toastr/toastr.min.css"/>

	    <script>
		    Session.Id = '<?php echo session_id(); ?>';
		    Session.Timestamp  = '<?php $time = time(); echo $time; ?>';
		    Session.Hash = '<?php echo SessionHash(session_id(),$time); ?>';
		    Session.URL = '<?=GetProjectUrl(); ?>';
		    Session.SiteURL = '<?=GetProjectUrl(); ?>';
		    Session.actionPrefix = 'do';
		    Session.controllerMethodPattern = "{0}.{1}";
		    Session.CurrentUser = new User(<?=json_encode($loggedUser ? $loggedUser->Serialize(true) : null)?>);

		    Entity.Options.Save.controller = "Entity";
		    Entity.Options.Save.method = "Save";
		    Entity.Options.Save.preMessage = "Salvando...";
		    Entity.Options.Save.successMessage = "Salvo com sucesso!";

		    Entity.Options.Delete.controller = "Entity";
		    Entity.Options.Delete.method = "Delete";
		    Entity.Options.Delete.preMessage = "Removendo...";
		    Entity.Options.Delete.successMessage = "Removido com sucesso!";

		    Entity.Options.Select.controller = "Entity";
		    Entity.Options.Select.method = "Select";

		    Number.setDecimalChar(',');

		    toastr.options = {
			    "closeButton": false,
			    "debug": false,
			    "newestOnTop": true,
			    "progressBar": true,
			    "positionClass": "toast-top-right",
			    "preventDuplicates": false,
			    "showDuration": "300",
			    "hideDuration": "300",
			    "timeOut": "5000",
			    "extendedTimeOut": "1000",
			    "showEasing": "swing",
			    "hideEasing": "swing",
			    "showMethod": "fadeIn",
			    "hideMethod": "fadeOut"
		    };
		    function toast(type, msg, title, timeout){
			    timeout = timeout!==null ? {timeOut: timeout} : null;
			    return toastr[type](msg, title, timeout);
		    }
	    </script>
    </head>
	
	<?=VueParser::Inline('Pane')?>
	<?=VueParser::Inline('Pager')?>
	<?=VueParser::Inline('PagedTable')?>
	
    <body class="scrollable">
	    <div class="container-fluid">
		    <div class="row flex">
			    <div class="col-lg-2 col-md-4 col-xs-6 main-menu no-select">
				    <?PHP if($loggedUser){ ?>
					    <span class="toggle-icon glyphicon glyphicon-menu-hamburger"
					          onclick="$('.main-menu').toggleClass('shown')"></span>

					    <span class="hide-icon glyphicon glyphicon-remove"
					          onclick="$('.main-menu').toggleClass('shown')"></span>
					    <div style="padding: 1em 1em 0;">
						    <?PHP if($loggedUser->Avatar->Exists()){ ?>
						    <div class="circle pull-left" style="width: 50px; height: 50px; margin-right: 15px;">
							    <img src="<?=$loggedUser->AvatarThumb->GetUrl()?>" alt="">
						    </div>
						    <?PHP } ?>
						    <h4 style="margin: 0;"><?=$loggedUser->DisplayName?></h4>
						    <a href="<?=GetActionUrl('Auth', 'Logout')?>" onclick="Loading.Show(0,'Saindo...')">Sair</a>
					    </div>
					    <a href="/">
						    <span class="glyphicon glyphicon-home"></span>
						    Home
					    </a>
					    <a href="/ApprovalQueue">
						    <span class="glyphicon glyphicon-inbox"></span>
						    Fila de aprovação
					    </a>
					    <a href="/Users">
						    <span class="glyphicon glyphicon-user"></span>
						    Usuários
					    </a>
					    <a href="/Plans">
						    <span class="glyphicon glyphicon-flash"></span>
						    Planos
					    </a>
					    <a href="/GoodTypes">
						    <span class="glyphicon glyphicon-star-empty"></span>
						    Tipos de Bens
					    </a>
					    <a href="/Goods">
						    <span class="glyphicon glyphicon-star"></span>
						    Bens
					    </a>
					    <a href="/Reservations">
						    <span class="glyphicon glyphicon-bookmark"></span>
						    Reservas
					    </a>

                        <div class="text-center" style="position:absolute;left: 0;right: 0;bottom: 0;padding: 10px 0; font-size: .8em">
                            Seu último acesso foi em: <br> <?=date('d/m/Y H:i:s', $loggedUser->LastAccessDate)?> (UTC)
                        </div>
				    <?PHP } ?>
			    </div>
			    <div class="col-lg-10 col-md-12 col-xs-12 main-content">
				    <?PHP View::Load($page); ?>
			    </div>
		    </div>
	    </div>
    </body>
</html>