<h2>Tipos de Bem</h2>

<div id="plans">
	<entity-manager ref="manager" model="GoodType">
		<template slot="table-head">
            <th>Nome</th>
            <th>Bens</th>
		</template>
		<template slot="table-item" scope="data">
			<td>{{data.item.Name}}</td>
            <td>{{quantities[data.item.Id]}}</td>
		</template>
		<template slot="edit" scope="data">
			<h4>Editar Tipo de Bem</h4>
			<div class="row">
				<div class="col-sm-4 col-xs-6">
					<label>Nome</label>
					<input type="text" class="form-control" v-model="data.item.Name">
				</div>
				<div class="col-sm-4 col-xs-6">
					<label>Nome no plural</label>
					<input type="text" class="form-control" v-model="data.item.NamePlural">
				</div>
				<div class="col-sm-4 col-xs-6">
					<label>Gênero</label>
					<select class="form-control" v-model="data.item.Gender">
						<option value="0">Escolha...</option>
						<option value="1">Masculino</option>
						<option value="2">Feminino</option>
					</select>
				</div>
			</div>

			<label>Reserva possúi</label>
			<div class="row">
				<div class="col-sm-4 col-xs-6">
					<label>Período de Tempo</label>
					<div class="btn btn-block" :class="data.item.HasPeriod ? 'btn-success' : 'btn-danger'" v-on:click="data.item.HasPeriod = !data.item.HasPeriod">
						{{data.item.HasPeriod ? 'Sim' : 'Não'}}
						<span class="glyphicon" :class="data.item.HasPeriod ? 'glyphicon-ok' : 'glyphicon-remove'"></span>
					</div>
				</div>
				<div class="col-sm-4 col-xs-6">
					<label>Local Inicial</label>
					<div class="btn btn-block" :class="data.item.HasPickupAddress ? 'btn-success' : 'btn-danger'" v-on:click="data.item.HasPickupAddress = !data.item.HasPickupAddress">
						{{data.item.HasPickupAddress ? 'Sim' : 'Não'}}
						<span class="glyphicon" :class="data.item.HasPickupAddress ? 'glyphicon-ok' : 'glyphicon-remove'"></span>
					</div>
				</div>
				<div class="col-sm-4 col-xs-6">
					<label>Local Final</label>
					<div class="btn btn-block" :class="data.item.HasDestinationAddress ? 'btn-success' : 'btn-danger'" v-on:click="data.item.HasDestinationAddress = !data.item.HasDestinationAddress">
						{{data.item.HasDestinationAddress ? 'Sim' : 'Não'}}
						<span class="glyphicon" :class="data.item.HasDestinationAddress ? 'glyphicon-ok' : 'glyphicon-remove'"></span>
					</div>
				</div>
			</div>

			<label>Planos permitidos</label>
			<div class="row">
				<div class="col-md-1 col-sm-2 col-xs-4" v-for="plan in plans">
					<label>
						<input type="checkbox" :value="plan.Id" v-model="data.item.PlansAllowed"> {{plan.Name}}
					</label>
				</div>
			</div>
		</template>
	</entity-manager>
</div>

<?=VueParser::Inline('EntityManager')?>

<?=ScriptDependency::Current()->IncludeScript('entities/Plan')?>
<?=ScriptDependency::Current()->IncludeScript('entities/Good')?>
<script>
	var plansVM = new Vue({
		el: '#plans',
		data: {
			plans: [],
            quantities: []
		},
		computed: {
		},
		methods: {
		},
		mounted: function () {
			var vm = this;

			Plan.Select(function (data) {
                vm.plans = data;
			}, {
				filter: {
					//Active: 1
				}
			});

			this.$refs.manager.$on('load', function (data) {
			    debugger;
                for(var i = 0; i < data.length; i++){
                    var item = data[i];

                    Good.Select((function (r, cnt) {
                        vm.$set(vm.quantities, this.Id, cnt);
                    }).bind(item), {
                        filter: {
                            TypeId: item.Id
                        },
                        method: 'CountSelect'
                    });
                }
            })
		}
	});
</script>