<h2>Planos</h2>

<div id="plans">
	<entity-manager ref="manager" model="Plan" :remove-enabled="false" :create-enabled="true" order="`Index` ASC">
		<template slot="table-head">
			<th style="width:70px">Idx</th>
			<th>Nome</th>
			<th style="width:10%;">Valor Mensal</th>
			<th style="width:10%;">Pontos Mensais</th>
			<th style="width:10%;" class="hidden-xs">Dependentes</th>
			<th style="width:10%;" class="hidden-xs">Pontos Extras</th>
			<th style="width:10%;" class="hidden-xs">Validade dos pts.</th>
			<th style="width:10%;" class="hidden-xs">Fidelidade</th>
            <th style="width:10%;">Ativo</th>
            <th style="width:10%;">Clientes</th>
			<!--<th style="width:150px;"></th>|-->
		</template>
		<template slot="table-item" scope="data">
			<td>{{data.item.Index}}</td>
			<td>{{data.item.Name}}</td>
			<td>R$ {{data.item.MonthlyCost.pad(0,2)}}</td>
			<td>{{data.item.creditsPerMonth()}}</td>
			<td class="hidden-xs">{{data.item.MaxDependents}}</td>
			<td class="hidden-xs">{{data.item.CreditsBonus}}%</td>
			<td class="hidden-xs">{{data.item.CreditsExpiryInMonths}}</td>
			<td class="hidden-xs">{{data.item.MinimumMembershipTime}}</td>
			<td>
				<span class="glyphicon" :class="data.item.Active ? 'glyphicon-ok' : 'glyphicon-remove'"></span>
			</td>
            <td>{{quantities[data.item.Id]}}</td>
		</template>
		<template slot="edit" scope="data">
			<h4>Editar Plano</h4>
			<div class="row">
				<div class="col-sm-1 col-xs-6">
					<label>Índice</label>
					<input type="number" min="0" class="form-control" v-model="data.item.Index">
				</div>
				<div class="col-sm-3 col-xs-6">
					<label>Nome</label>
					<input type="text" class="form-control" v-model="data.item.Name">
				</div>
				<div class="col-sm-3 col-xs-6">
					<label>Valor Mensal</label>
					<div class="input-group">
						<span class="input-group-addon">$</span>
						<input type="number" min="0" class="form-control" v-model="data.item.MonthlyCost">
					</div>
				</div>
				<div class="col-sm-3 col-xs-6">
					<label>Pontos Extras</label>
					<div class="input-group">
						<input type="number" min="0" class="form-control" v-model="data.item.CreditsBonus">
						<span class="input-group-addon">%</span>
					</div>
				</div>
				<div class="col-sm-2 col-xs-6">
					<label>Pontos Mensais</label>
					<input type="number" min="0" class="form-control" :value="data.item.creditsPerMonth()" disabled>
				</div>
			</div>

			<div class="row">
				<div class="col-sm-2 col-xs-6">
					<label>Validade Pts</label>
					<input type="number" min="0" class="form-control" v-model="data.item.CreditsExpiryInMonths">
				</div>
				<div class="col-sm-2 col-xs-6">
					<label>Dependentes (max)</label>
					<input type="number" min="0" class="form-control" v-model="data.item.MaxDependents">
				</div>
				<div class="col-sm-3 col-xs-6">
					<label>Fidelidade Mínima</label>
					<input type="number" min="0" class="form-control" v-model="data.item.MinimumMembershipTime">
				</div>
				<div class="col-sm-3 col-xs-6">
					<label>Status</label>
					<div class="btn btn-block" :class="data.item.Active ? 'btn-primary' : 'btn-danger'" v-on:click="data.item.Active = !data.item.Active">
						<span class="glyphicon" :class="data.item.Active ? 'glyphicon-eye-open' : 'glyphicon-eye-close'"></span>
						{{data.item.Active ? 'Ativo' : 'Inativo'}}
					</div>
				</div>
			</div>
		</template>
	</entity-manager>
</div>

<div class="row">
    <div class="col-md-12">
        <br>
        <a href="/do/CSV.Plans" class="btn btn-success pull-right">
            Baixar todos em CSV <span class="glyphicon glyphicon-download"></span>
        </a>
    </div>
</div>

<?=VueParser::Inline('EntityManager')?>

<?=ScriptDependency::Current()->IncludeScript('entities/Plan')?>
<?=ScriptDependency::Current()->IncludeScript('entities/Subscription')?>
<script>
	var plansVM = new Vue({
		el: '#plans',
		data: {
            quantities: []
		},
		computed: {
		},
		methods: {
		},
		mounted: function () {
            var vm = this;

            this.$refs.manager.$on('load', function (data) {

                for(var i = 0; i < data.length; i++){
                    var item = data[i];

                    Subscription.Select((function (r, cnt) {
                        vm.$set(vm.quantities, this.Id, cnt);
                    }).bind(item), {
                        filter: {
                            EndDate: {
                                values: ['NULL'],
                                operator: 'IS',
                                bound: 0
                            },
                            PlanId: item.Id
                        },
                        method: 'CountSelect'
                    });
                }
            })
		}
	});
</script>