<h2>Reservas</h2>

<div id="main">
	<pane ref="table">
		<paged-table :items="filteredReservations">
		<template slot="head">
			<tr>
				<th style="width:100px;">Id</th>
				<th style="width:20%;">Sócio</th>
				<th style="width:20%;">Bem</th>
				<th class="hidden-xs" style="width:250px;">Data</th>
				<th style="width:100px">Custo</th>
				<th>Status</th>
				<th style="width:75px;"></th>
			</tr>
		</template>
		<template slot="item" scope="data">
			<tr>
				<td>{{data.item.Id.pad(3)}}</td>
				<td>
					{{data.item.Renter.DisplayName}}
				</td>
				<td>
					{{data.item.Good.Brand}} {{data.item.Good.Model}}
					<i style="color: #666">({{data.item.Good.Code}})</i>
				</td>
				<td class="hidden-xs">
					<template v-if="data.item.StartDateTime.getTime() == data.item.EndDateTime.getTime()">
						{{data.item.StartDateTime.format('d/m/Y - H:i:s')}}
					</template>
					<template v-else-if="data.item.StartDateTime.format('d/m/Y') == data.item.EndDateTime.format('d/m/Y')">
						{{data.item.StartDateTime.format('d/m/Y')}} <br>
						{{data.item.StartDateTime.format('H:i:s')}} ~
						{{data.item.EndDateTime.format('H:i:s')}}
					</template>
					<template v-else>
						De: {{data.item.StartDateTime.format('d/m/Y - H:i:s')}} <br>
						Até: {{data.item.EndDateTime.format('d/m/Y - H:i:s')}}
					</template>
				</td>
				<td>
					{{data.item.getCost()}} pontos
				</td>
				<td :class="'text-'+status._classes[data.item.Status]">
					{{status._strings[data.item.Status]}}
				</td>
				<td>
					<div class="btn btn-sm btn-block btn-primary" v-on:click="edit(data.item)"
					     v-popover.top.hover="'Detalhes'">
						<span class="glyphicon glyphicon-eye-open"></span>
					</div>
				</td>
			</tr>
		</template>
	</paged-table>
	</pane>
	<pane ref="edit" :expanded="false">
		<template v-if="editing">
			<h3>Reserva {{editing.Id.pad(5)}}</h3>

			<div class="row">
				<div class="col-sm-4 col-xs-12">
					<h4>Sócio</h4>

					<b>Nome:</b> {{editing.Renter.FullName}}<br>

					<b>Email:</b> <a :href="'mailto:'+editing.Renter.Email">{{editing.Renter.Email}}</a><br>
					<b>Telefone:</b> {{editing.Renter.Telephone}} <br>

					<b>Saldo:</b> {{editing.Renter.Balance}} pontos

					<div class="alert action alert-warning"
					     v-if="editing.Status == status.Pending && editing.getCost() > editing.Renter.Balance">
						<div class="btn btn-sm btn-primary pull-right" v-on:click="fillBalanceGap">
							Completar saldo (+{{editing.getCost() - editing.Renter.Balance}})
						</div>
						Aviso: Saldo insuficiente!

					</div>
					<div class="alert action alert-warning"
					     v-if="editing.Status == status.Started && editing.ExtraCredits > editing.Renter.Balance">
						<div class="btn btn-sm btn-primary pull-right" v-on:click="fillBalanceGap">
							Completar saldo (+{{editing.ExtraCredits - editing.Renter.Balance}})
						</div>
						Aviso: Saldo insuficiente!
					</div>
				</div>

				<div class="col-sm-4 col-xs-12">
					<h4>Bem</h4>
					<b>Código:</b> {{editing.Good.Code}}<br>

					<b>Modelo:</b> {{editing.Good.Brand}} {{editing.Good.Model}}<br>

					<b>Tipo:</b> {{editing.Good.Type.Name}}<br>

					<b>Custo:</b> {{editing.Good.DefaultCost}}
					+ {{editing.Good.VariableCost}}/{{measurements._strings[editing.Good.VariableCostMeasurement]}}<br>
				</div>

				<div class="col-sm-4 col-xs-12">
					<h4>Reserva</h4>
					<b>Período:</b>
					<template v-if="editing.StartDateTime.getTime() == editing.EndDateTime.getTime()">
						{{editing.StartDateTime.format('d/m/Y - H:i:s')}}
					</template>
					<template v-else-if="editing.StartDateTime.format('d/m/Y') == editing.EndDateTime.format('d/m/Y')">
						{{editing.StartDateTime.format('d/m/Y')}},
						{{editing.StartDateTime.format('H:i:s')}} ~
						{{editing.EndDateTime.format('H:i:s')}}
					</template>
					<template v-else>
						De: {{editing.StartDateTime.format('d/m/Y - H:i:s')}} -
						Até: {{editing.EndDateTime.format('d/m/Y - H:i:s')}}
					</template>
					<br>

					<b>Custo:</b> {{editing.getCost()}} pontos<br>

					<b>Status:</b>
					<span :class="'text-'+status._classes[editing.Status]">{{status._strings[editing.Status]}}</span><br>

					<b>Check-in:</b> {{editing.CheckInTime ? editing.CheckInTime.format('d/m/Y - H:i:s') : '-'}}<br>

					<b>Check-out:</b> {{editing.CheckOutTime ? editing.CheckOutTime.format('d/m/Y - H:i:s') : '-'}}<br>

				</div>
			</div>

			<div class="row">
				<div class="col-sm-4 col-xs-12">
					<h4>Dados</h4>

					<div class="row no-select">
						<div class="col-md-6" v-if="editing.Meta.pickupPlace">
							<label>Origem:</label><br>
							<a :href="editing.Meta.pickupPlace.url" target="_blank" class="glyphicon glyphicon-map-marker"
							       v-popover.hover.top.body="editing.Meta.pickupPlace.formatted_address"></a>
							{{editing.Meta.pickupPlace.name}}
						</div>
						<div class="col-md-6" v-if="editing.Meta.destinationPlace">
							<label>Destino:</label><br>
							<a :href="editing.Meta.destinationPlace.url" target="_blank" class="glyphicon glyphicon-map-marker"
							   v-popover.hover.top.body="editing.Meta.destinationPlace.formatted_address"></a>
							{{editing.Meta.destinationPlace.name}}
						</div>

						<div class="col-md-12" v-if="editing.Meta.distance">
							<label>Distância estimada:</label> {{editing.Meta.distance}} km
						</div>
					</div>
					
					<div class="row">
						<div class="col-xs-4">
							<div class="form-group">
								<label>Custo fixo:</label>
								<input type="number" min="0" class="form-control" v-model="editing.FixedCredits"
								       :disabled="editing.Status != status.Pending">
							</div>
						</div>

						<div class="col-xs-4">
							<div class="form-group">
								<label>Custo variável:</label>
								<input type="number" min="0" class="form-control" v-model="editing.VariableCredits"
								       :disabled="editing.Status != status.Pending">
							</div>
						</div>

						<div class="col-xs-4">
							<div class="form-group">
								<label>Custo extra:</label>
								<input type="number" min="0" class="form-control" v-model="editing.ExtraCredits"
								       :disabled="editing.Status != status.Started">
							</div>
						</div>
					</div>

                    <div class="form-group">
                        <label>Observações:</label>
                        <textarea class="form-control" v-model="editing.Observations" style="min-height: 131px"
                                  :disabled="editing.Status >= status.Finished"></textarea>
                    </div>

                    <div class="form-group">
                        <label>
                            <input type="checkbox" v-model="editing.ManualPayment" :disabled="editing.Status >= status.Finished"
                                   v-on:click="editing.PaymentUserId = currentUser.Id">
                            Pagamento manual?
                        </label>

                        <template v-if="editing.ManualPayment">
                            <br>
                            <label>Informe o código de autorização:</label>
                            <input type="text" class="form-control" v-model="editing.PaymentCode" :disabled="editing.Status >= status.Finished">
                            <br>
                            Autorizado pelo usuário #{{editing.PaymentUserId}}
                        </template>
                    </div>

					<div class="btn btn-success pull-right" v-on:click="editing.Save()"
						v-if="editing.Status < status.Finished">
						<span class="glyphicon glyphicon-floppy-disk"></span>
						Salvar dados
					</div>
				</div>
				<div class="col-sm-8 col-xs-12">
					<h4>
						Endereço
						<small class="glyphicon glyphicon-question-sign"
						       v-popover.hover.top="'Preencher caso haja um endereço aonde o sócio deverá encontrar o bem (marina, heliporto...)'"></small>
					</h4>
					<address-edit v-model="editing.PickupAddress"></address-edit>
					<div class="btn btn-success pull-right" v-on:click="editing.PickupAddress.Save()">
						<span class="glyphicon glyphicon-home"></span>
						Salvar endereço
					</div>
				</div>
			</div>





			<!-- footer-->
			<br>
			<div class="row">
				<div class="col-sm-3 col-xs-6">
					<div class="btn btn-block btn-warning" v-on:click="cancelEditing">
						<span class="glyphicon glyphicon-chevron-left"></span>
						Voltar
					</div>
				</div>
				<div class="col-sm-6 hidden-xs"></div>
				<div class="col-sm-3 col-xs-6">

					<div class="row" v-if="editing.Status == status.Pending">
						<div class="col-xs-6">
							<div class="btn btn-block btn-danger" v-on:click="deny">
								<span class="glyphicon glyphicon-remove"></span>
								Negar
							</div>
						</div>
						<div class="col-xs-6">
							<button class="btn btn-block btn-success" v-on:click="approve" :disabled="!canApprove"
							     v-popover.hover.left.body="'Ao aprovar o custo será debitado da conta do usuário e não será mais editável.'">
								<span class="glyphicon glyphicon-ok"></span>
								Aprovar
							</button>
						</div>
					</div>

					<div class="row" v-if="editing.Status == status.Approved">
						<div class="col-xs-6">
							<button class="btn btn-block btn-danger" v-on:click="cancel"
							     v-popover.hover.left.body="'Ao cancelar os pontos gastos serão estornados.'">
								<span class="glyphicon glyphicon-remove-sign"></span>
								Cancelar
							</button>
						</div>
						<div class="col-xs-6">
							<button class="btn btn-block btn-success" v-on:click="start">
								<span class="glyphicon glyphicon-log-in"></span>
								Check-in
							</button>
						</div>
					</div>

					<div class="row" v-if="editing.Status == status.Started">
						<div class="col-xs-6"></div>
						<div class="col-xs-6">
							<button class="btn btn-block btn-success" v-on:click="finish" :disabled="editing.ExtraCredits > editing.Renter.Balance">
								<span class="glyphicon glyphicon-log-out"></span>
								Check-out
							</button>
						</div>
					</div>




				</div>
			</div>
		</template>
	</pane>
</div>

<?=VueParser::Inline('EntityManager')?>
<?=VueParser::Inline('entity/AddressEdit')?>

<?=ScriptDependency::Current()->IncludeScript('entities/Plan')?>
<?=ScriptDependency::Current()->IncludeScript('entities/Reservation')?>
<script>
	var mainVM = new Vue({
		el: '#main',
		data: {
			items: [],
			selectedStatus: null,

			measurements: Good.UsageMeasurement,
			status: Reservation.Status,

			editing: null,
			editingIdx: 0,
            currentUser: Session.CurrentUser
		},
		computed: {
			filteredReservations: function () {
				var vm = this;

				if (vm.selectedStatus === null){
					return vm.items;
				}

				return vm.items.filter(function (e) {
					return e.Status === vm.selectedStatus;
				});
			},
			canApprove: function(){
				return this.editing && this.editing.getCost() <= this.editing.Renter.Balance;
			}
		},
		methods: {
			edit: function (item) {
				this.editing = new Reservation(item.Serialize());
				this.editingIdx = this.items.indexOf(item);

				this.editing.off('save');
				var vm = this;
				this.editing.once('save', function () {
					if (vm.editingIdx >= 0){
						vm.items[vm.editingIdx].FillFromArray(vm.editing.Serialize());
					}
				});

				this.$refs.table.hideNext();
				this.$refs.edit.showNext();
			},
			cancelEditing: function () {
				this.$refs['table'].show();
				this.$refs['edit'].hide();
			},
			approve: function () {
				var vm = this;

				Loading.Show();

				this.editing.once('save', function () {
					Session.Do('Reservation', 'Approve',{
						id: vm.editing.Id
					}, function (result) {
						Loading.Hide();
						if (result && result.Id){
							vm.editing.FillFromArray(result);
						}
					});
				});

				this.editing.Save();
			},
			deny: function () {
//				this.editing.Status = this.status.Denied;
//				this.editing.Save();
                var vm = this;
                Loading.Show();

                this.editing.once('save', function () {
                    Session.Do('Reservation', 'Deny',{
                        id: vm.editing.Id
                    }, function (result) {
                        Loading.Hide();
                        if (result && result.Id){
                            vm.editing.FillFromArray(result);
                        }
                    });
                });

                this.editing.Save();
			},
			cancel: function () {
				var vm = this;

				Loading.Show('Cancelando reserva...');

				Session.Do('Reservation', 'Cancel',{
					id: this.editing.Id
				}, function (result) {
					Loading.Hide();
					if (result && result.Id){
						vm.editing.FillFromArray(result);
					}
				});
			},
			start: function () {
				var vm = this;

				Loading.Show('Fazendo check-in...');
				Session.Do('Reservation', 'Start',{
					id: this.editing.Id
				}, function (result) {
					Loading.Hide();
					if (result && result.Id){
						vm.editing.FillFromArray(result);
					}
				});
			},
			finish: function () {
				var vm = this;

				Loading.Show('Fazendo check-out');

				this.editing.once('save', function () {
					Session.Do('Reservation', 'Finish',{
						id: vm.editing.Id
					}, function (result) {
						Loading.Hide();
						if (result && result.Id){
							vm.editing.FillFromArray(result);
						}
					});
				});

				this.editing.Save();
			},

			fillBalanceGap: function () {
				var cost = 0;

				if (this.editing.Status == this.status.Pending && this.editing.getCost() > this.editing.Renter.Balance){
					cost = this.editing.getCost() - this.editing.Renter.Balance;
				}else if (this.editing.Status == this.status.Started && this.editing.ExtraCredits > this.editing.Renter.Balance){
					cost = this.editing.ExtraCredits - this.editing.Renter.Balance;
				}

				if (cost){
					var vm = this;

					Loading.Show(0, 'Adicionando '+cost+' pontos ao saldo...');

					Session.Do('Balance', 'Change',{
						id: this.editing.Renter.Id,
						amount: cost,
						description: 'Compra de pontos adicionais'
					}, function (result) {
						Loading.Hide();
						if (result && result.Id){
							vm.editing.Renter.Balance += parseInt(result.Amount);
						}
					});
				}
			}
		},
		mounted: function () {
			var vm = this;

			Loading.Show();
			Reservation.Select(function (data) {
				Loading.Hide();
				vm.items = data;
			}, {
				filter: {
				},
				order: 'Id DESC'
			})
		}
	});
</script>