<h2>Usuários</h2>

<div id="users">
	<pane ref="table">
        <label>Filtrar por:</label>
        <div class="row">
            <div class="col-md-4 col-sm-6 col-xs-12">
                <label for="">Nome de Exibição</label>
                <input type="text" class="form-control" v-model="filter.name" placeholder="Nome">
            </div>
            <div class="col-md-4 col-sm-6 col-xs-12">
                <label for="">Nome de Registro</label>
                <input type="text" class="form-control" v-model="filter.fullname" placeholder="Nome Completo">
            </div>
            <div class="col-md-4 col-sm-6 col-xs-12">
                <label for="">Email</label>
                <input type="text" class="form-control" v-model="filter.email" placeholder="Email">
            </div>
            <div class="col-md-4 col-sm-6 col-xs-12">
                <label for="">CPF</label>
                <input type="text" class="form-control" v-model="filter.cpf" placeholder="CPF">
            </div>
            <div class="col-md-4 col-sm-6 col-xs-12">
                <label for="">Papel</label><br>
                <div class="btn-group">
                    <button class="btn" :class="filter.roles & role ? 'btn-primary' : 'btn-default'" v-for="(str, role) in roles._strings"
                            v-on:click="filterRole(role)">{{str}}</button>
                </div>
            </div>
        </div>

		<paged-table :items="filteredUsers">
			<template slot="head">
				<tr>
					<th style="width:75px;">Id</th>
					<th style="width:20%;">Nome de exibição</th>
					<th style="width:10%;">Cidade/Estado</th>
					<th style="width:20%;">Plano</th>
					<th style="width:10%;">Saldo</th>
					<th>Email</th>
					<th style="width:75px;"></th>
				</tr>
			</template>
			<template slot="item" scope="data">
				<tr>
					<td>{{data.item.Id}}</td>
					<td>
						<small class="glyphicon glyphicon-king pull-right" v-if="data.item.hasRole(roles.Admin)"
						       v-popover.top.hover="'Admin'"></small>
						<small class="glyphicon glyphicon-wrench pull-right" v-if="data.item.hasRole(roles.Operator)"
						       v-popover.top.hover="'Operador'"></small>
						{{data.item.DisplayName}}

					</td>
					<td>{{data.item.Address.City}}/{{data.item.Address.State}}</td>
					<td>
						<template v-if="data.item.CurrentSubscription">
							{{data.item.CurrentSubscription.Plan.Name}}
							(R$ {{data.item.CurrentSubscription.MonthlyCost.pad(0,2)}}/{{data.item.CurrentSubscription.Plan.CreditsPerMonth}} pontos)
						</template>
						<template v-else>
							<i>nenhum</i>
						</template>
					</td>
					<td>{{data.item.Balance}} pontos</td>
					<td>{{data.item.Email}}</td>
					<td>
						<button class="btn btn-sm btn-block btn-info" v-on:click="edit(data.item)"
						     v-popover.top.hover="'Visualizar detalhes'">
							<span class="glyphicon glyphicon-eye-open"></span>
						</button>
					</td>
					<td>
						<button class="btn btn-sm btn-block btn-success" v-on:click="openPlans(data.item)"
						     v-popover.top.hover="'Assinatura e Saldo'" :disabled="!data.item.hasRole(roles.Member)">
							<span class="glyphicon glyphicon-usd"></span>
						</button>
					</td>
					<td>
						<button class="btn btn-sm btn-block btn-danger" v-on:click="remove(data.item)"
						     v-popover.top.hover="'Excluir'">
							<span class="glyphicon glyphicon-remove"></span>
						</button>
					</td>
				</tr>
			</template>
		</paged-table>

        <div class="btn btn-success pull-right" v-on:click="create">
            Novo
        </div>


        <div class="row">
            <div class="col-md-12">
                <br>
                <a href="/do/CSV.Users" class="btn btn-success pull-right">
                    Baixar todos em CSV <span class="glyphicon glyphicon-download"></span>
                </a>
            </div>
        </div>
	</pane>
	<pane ref="edit" :expanded="false">
		<template v-if="editing">
			<h4>Detalhes</h4>

			<div class="row">
				<div class="col-sm-6 col-xs-12">
					<label>Nome Completo</label>
					<input class="form-control" v-model="editing.FullName" :disabled="!editEnabled">
				</div>
				<div class="col-sm-6 col-xs-12">
					<label>Nome de Exibição</label>
					<input class="form-control" v-model="editing.DisplayName" :disabled="!editEnabled">
				</div>
			</div>
			<div class="row">
				<div class="col-sm-6 col-xs-12">
					<label>Email</label>
					<input type="email" class="form-control" v-model="editing.Email" :disabled="!editEnabled">
				</div>
				<div class="col-sm-6 col-xs-12">
					<label>Resetar Senha</label>
					<input class="form-control" v-model="editing.SetPassword"
					       v-popover.top.focus="'Se prenchido irá alterar a senha do usuário'" :disabled="!editEnabled">
				</div>
			</div>
			<div class="row">
				<div class="col-sm-3 col-xs-6">
					<label>Gênero</label>
					<select class="form-control" v-model="editing.Gender" :disabled="!editEnabled">
						<option value="">Escolha...</option>
						<option value="1">Masculino</option>
						<option value="2">Feminino</option>
						<option value="3">Não binário</option>
						<option value="4">Prefiro Não informar</option>
					</select>
				</div>
				<div class="col-sm-3 col-xs-6">
					<label>CPF</label>
					<input type="tel" class="form-control" v-model="editing.CPF" :disabled="!editEnabled">
				</div>
				<div class="col-sm-3 col-xs-6">
					<label>Telefone</label>
					<input type="tel" class="form-control" v-model="editing.Telephone" :disabled="!editEnabled">
				</div>
				<div class="col-sm-3 col-xs-6">
					<label>Nascimento</label>
					<date-input class="form-control" v-model="editing.Birthday" :disabled="!editEnabled"></date-input>
				</div>
			</div>

			<h4>Endereço</h4>
			<address-edit v-model="editing.Address" :edit-enabled="editEnabled"></address-edit>

            <div class="row">
                <div class="col-md-6">
                    <h4>Papéis</h4>

                    <div class="btn-group">
                        <button class="btn" :class="editing.hasRole(role) ? 'btn-primary' : 'btn-default'" v-for="(str, role) in roles._strings"
                                v-on:click="selectRole(role)" :disabled="!editEnabled">{{str}}</button>
                    </div>
                </div>
                <div class="col-md-6" v-if="editing.ApprovalUser">
                    <h4>Aprovação</h4>
                    Aprovado em <b>{{editing.ApprovalDate.format('d/m/Y H:i:s')}}</b> pelo usuário <b>{{editing.ApprovalUser.DisplayName}}</b>
                </div>
            </div>

			<br>
			<div class="row">
				<div class="col-sm-3 col-xs-6">
					<div class="btn btn-block btn-warning" v-on:click="cancelEditing">
						<span class="glyphicon glyphicon-chevron-left"></span>
						Voltar
					</div>
				</div>
				<div class="col-sm-3 hidden-xs"></div>
                <div class="col-sm-3 col-xs-3">
                    <div class="btn btn-block btn-primary" v-on:click="recoverPassword" v-popover.top.hover="'Enviará um email com um link de recuperação de senha'">
                        Recuperar senha
                        <span class="glyphicon glyphicon-lock"></span>
                    </div>
                </div>
                <div class="col-sm-3 col-xs-3" v-if="editEnabled">
                    <div class="btn btn-block btn-success" v-on:click="save">
                        Salvar
                        <span class="glyphicon glyphicon-ok"></span>
                    </div>
                </div>
                <div class="col-sm-3 col-xs-3" v-else>
                    <div class="btn btn-block btn-info" v-on:click="editEnabled = !editEnabled">
                        Habilitar edição
                        <span class="glyphicon glyphicon-pencil"></span>
                    </div>
                </div>
			</div>
		</template>
	</pane>
	<pane ref="plans" :expanded="false">
		<template v-if="editing">
			<div class="circle pull-right" style="width: 100px; height: 100px;" v-if="editing.HasAvatar">
				<img :src="editing.avatarUrl()" alt="">
			</div>

			<h3 class="text-center">{{editing.DisplayName}} - Balanço Geral</h3>
			<h4>Assinaturas</h4>

			<div class="row">
				<div class="col-sm-6 col-xs-12">
					<paged-table :items="subscriptionHistory" :results-per-page="4">
						<template slot="head">
							<tr>
								<th>Plano</th>
								<th style="width:200px;">Início</th>
								<th style="width:200px;">Fim</th>
							</tr>
						</template>
						<template slot="item" scope="data">
							<tr :style="{color: data.item.EndDate ? '#aaa' : ''}">
								<td>
									{{data.item.Plan.Name}}
									(R$ {{data.item.MonthlyCost.pad(0,2)}}/{{data.item.Plan.CreditsPerMonth}} pontos)
								</td>
								<td>
									{{data.item.StartDate.format('d/m/Y H:i:s')}}
								</td>
								<td>
									{{data.item.EndDate ? data.item.EndDate.format('d/m/Y H:i:s') : 'Ainda ativa'}}
								</td>
							</tr>
						</template>
					</paged-table>
				</div>
				<div class="col-sm-6 col-xs-12">
					<label>Alterar plano</label>
					<div class="input-group">
						<select class="form-control" v-model="selectedPlan">
							<option value="0">Escolha...</option>
							<option v-for="plan in plans" :value="plan.Id">{{plan.Name}}</option>
						</select>
						<span class="input-group-btn">
							<button class="btn btn-info" type="button" :disabled="!selectedPlan" v-on:click="planChange">
								<span class="glyphicon glyphicon-chevron-right"></span>
							</button>
						</span>
					</div>
				</div>
			</div>

			<br>

			<h4>Pontos</h4>
			<div class="row">
				<div class="col-sm-2 col-xs-6">
					<label>Saldo atual: </label> <br>
					<span style="font-size: 2em">{{editing.Balance}}</span> pontos <br>
				</div>
				<div class="col-sm-4 col-xs-6">
                    <div class="btn btn-block btn-success" disabled v-popover.top.hover="'Indisponível'">
<!--                        v-on:click="openPurchase"-->
                        <span class="glyphicon glyphicon-usd"></span>
                        Realizar compra avulsa
                    </div>

                    <br>

					<label>Realizar movimentação arbitrária:</label>
					<input type="text" class="form-control" placeholder="Descrição" v-model="newBalanceOperation.Description">
					<div class="input-group">
						<input type="number" class="form-control" v-model="newBalanceOperation.Amount">
						<span class="input-group-btn">
							<button class="btn" type="button"
							        :disabled="!newBalanceOperation.Amount || !newBalanceOperation.Description"
							        :class="newBalanceOperation.Amount > 0 ? 'btn-success' : 'btn-danger'"
							        v-popover.top.hover="newBalanceOperation.Amount > 0 ? 'Crédito' : 'Débito'"
									v-on:click="balanceOperationCreate">
								<span class="glyphicon glyphicon-chevron-right"></span>
							</button>
						</span>
					</div>
				</div>
				<div class="col-sm-6 col-xs-12">
					<label>Extrato:</label>
					<paged-table :items="balanceOperationHistory" :results-per-page="4">
						<template slot="head">
							<tr>
								<th style="width:200px;">Data</th>
								<th>Descrição</th>
								<th style="width:200px;">Valor</th>
							</tr>
						</template>
						<template slot="item" scope="data">
							<tr :class="data.item.Type == 2 ? 'text-success' : 'text-danger'">
								<td>
									{{data.item.Date.format('d/m/Y H:i:s')}}
								</td>
								<td>
									{{data.item.Description}}
								</td>
								<td>
									{{data.item.Amount}} pontos
								</td>
							</tr>
						</template>
					</paged-table>
				</div>
			</div>


			<br>
			<div class="row">
				<div class="col-sm-3 col-xs-6">
					<div class="btn btn-block btn-warning" v-on:click="closePlans">
						<span class="glyphicon glyphicon-chevron-left"></span>
						Voltar
					</div>
				</div>
			</div>
		</template>
	</pane>

    <pane ref="purchase" :expanded="false">
        <template v-if="editing">
            <h4>Adicionar pontos</h4>

            <div class="row">
                <div class="col-sm-6 col-xs-12">
                    <label>Valor em R$</label>
                    <input class="form-control" type="number" v-model="buy.selectedAmount">
                </div>
                <div class="col-sm-6 col-xs-12">
                    <label>Total</label>
                    <h3>{{calculateCredits(buy.selectedAmount, editing)}} pontos</h3>
                </div>
            </div>



            <pagseguro-cc :user="editing" ref="cc" autofill-string="Usar dados do cliente"></pagseguro-cc>

            <br>

            <div class="row">
                <div class="col-sm-3 col-xs-6">
                    <div class="btn btn-block btn-warning" v-on:click="closePurchase">
                        <span class="glyphicon glyphicon-chevron-left"></span>
                        Voltar
                    </div>
                </div>
                <div class="col-sm-6 hidden-xs"></div>
                <div class="col-sm-3 col-xs-6">
                    <span class="btn btn-block" :class="($refs.cc && $refs.cc.isFilled) ? 'btn-success' : 'btn-disabled'" v-on:click="purchase">
                        <span class="glyphicon glyphicon-usd"></span>
                        Adquirir Pontos
                    </span>
                </div>
            </div>
        </template>
    </pane>
</div>

<?=VueParser::Inline('entity/AddressEdit')?>
<?=VueParser::Inline('PagseguroCC')?>
<?=ScriptDependency::Current()->IncludeScript('entities/User')?>
<?=ScriptDependency::Current()->IncludeScript('entities/BalanceOperation')?>
<?=ScriptDependency::Current()->IncludeScript('libs/jquery.payment.min')?>
<script>
	var usersVM = new Vue({
		el: '#users',
		data: {
			items: [],

            editEnabled: false,

			editing: null,
			editingIdx: null,

			plans: [],
			selectedPlan: 0,

			subscriptionHistory: [],

			newBalanceOperation: new BalanceOperation(),
			balanceOperationHistory: [],

			genders: User.Genders._strings,
			roles: User.Roles,

			filter: {
				roles: 0,
                name: "",
                fullname: "",
                cpf: "",
                email: ""
			},


            buy: {
                selectedAmount: 0
            }
		},
		computed: {
			filteredUsers: function () {
				var vm = this;
				return this.items.filter(function (e) {
					return ((e.Role & vm.filter.roles) || !vm.filter.roles) &&
                        (e.DisplayName.toLowerCase().indexOf(vm.filter.name.toLowerCase()) >= 0) &&
                        (e.FullName.toLowerCase().indexOf(vm.filter.fullname.toLowerCase()) >= 0) &&
                        (e.Email.toLowerCase().indexOf(vm.filter.email.toLowerCase()) >= 0) &&
                        (e.CPF.indexOf(vm.filter.cpf) >= 0);
				});
			}
		},
		methods: {
			filterRole: function (role) {
				if (this.filter.roles & role){
					this.filter.roles = this.filter.roles- role;
				}else{
					this.filter.roles = this.filter.roles | role;
				}
			},


			load: function () {
				var vm = this;

				Loading.Show();
				User.Select(function (data) {
					Loading.Hide();
					vm.items = data;
				}, {
					filter: {
						Status: {
							values: [3]
						}
					}
				});

				Plan.Select(function (data) {
					vm.plans = data;
				});
			},
			create: function () {
				this.editing = new User();
				this.editing.Status = 3;
				this.editingIdx = -1;
				this.showEdit();
			},
			edit: function (item) {
				this.editing = new User(item.Serialize());
				this.editingIdx = this.items.indexOf(item);
				this.showEdit();
			},
			showEdit: function () {
				var vm = this;

				this.editEnabled = false;

				this.editing.off('save');

				this.editing.once('save', function () {
					if (vm.editingIdx >= 0){
						vm.items[vm.editingIdx].FillFromArray(vm.editing.Serialize());
					}else{
						vm.items.push(new User(vm.editing.Serialize()));
					}

					vm.cancelEditing();
				});

				this.$refs.table.hideNext();
				this.$refs.edit.showNext();
			},

            recoverPassword: function () {
                var toastdiv = toast('info', '', 'Enviando...', 0);

                Session.Do('Auth', 'PasswordChangeRequest',{
                    email: this.editing.Email,
                    noredir: 1
                }, function (result) {
                    toastdiv.remove();
                    toast('success', 'Email com link enviado ao usuário', 'Enviado', 15000);
                })
            },


			selectRole: function (role) {
				if (this.editing.hasRole(role)){
					this.editing.Role = this.editing.Role - role;
				}else{
					this.editing.Role = this.editing.Role | role;
				}
				if (this.editing.Role < User.Roles._min){
                    this.editing.Role = User.Roles._min;
                }
			},

			cancelEditing: function () {
				this.$refs['table'].show();
				this.$refs['edit'].hide();
			},
			save: function () {
				this.editing.Save();
			},

			remove: function (item) {
				if (!confirm('Tem certeza quanto a excluir o usuário '+item.DisplayName+'?')) return;
				var vm = this;

				item.once('delete', function () {
					var idx = vm.items.indexOf(item);
					if (idx >= 0){
						vm.items.splice(idx, 1);
					}
				});

				item.Delete();
			},



			loadSubscriptionHistory: function () {
				var vm = this;

                var toastdiv = toast('info', '', 'Carregando assinaturas...', 0);

				Subscription.Select(function (data) {
					vm.subscriptionHistory = data;
                    toastdiv.remove();
				}, {
					filter: {
						UserId: {
							values: [this.editing.Id]
						}
					},
					order: 'StartDate DESC'
				});
			},
			loadBalanceOperationHistory: function () {
				var vm = this;

                var toastdiv = toast('info', '', 'Carregando extrato...', 0);

				BalanceOperation.Select(function (data) {
					vm.balanceOperationHistory = data;
                    toastdiv.remove();
				}, {
					filter: {
						UserId: {
							values: [this.editing.Id]
						}
					},
					order: 'Date DESC'
				});
			},

			openPlans: function (item) {
				this.editing = item;
				this.editingIdx = this.items.indexOf(item);

				this.subscriptionHistory = [];
				this.loadSubscriptionHistory();

				this.newBalanceOperation = new BalanceOperation();

				this.balanceOperationHistory = [];
				this.loadBalanceOperationHistory();

				this.$refs.table.hideNext();
				this.$refs.plans.showNext();
			},
			closePlans: function () {
				this.$refs.table.showNext();
				this.$refs.plans.hideNext();
			},

			planChange: function () {
				var vm = this;

				/** $var Plan[] */
				var selectedPlan = this.plans.filter(function (e) {
					return e.Id == vm.selectedPlan;
				});

				if (selectedPlan.length){
					selectedPlan = selectedPlan[0];

					var currentSub = this.editing.CurrentSubscription;
					if (currentSub &&
						currentSub.MonthlyCost == selectedPlan.MonthlyCost
						&& currentSub.CreditsPerMonth == selectedPlan.CreditsPerMonth
						&& currentSub.PlanId == selectedPlan.Id){

						alert('Esse já é o plano atual.');
						return;
					}
				}

				Loading.Show();
				Session.Do('User', 'NewSubscription',{
					userId: this.editing.Id,
					planId: this.selectedPlan
				}, function (result) {
					Loading.Hide();
					if (result && result.Id){
						var newSub = new Subscription(result);

						vm.editing.CurrentSubscription = newSub;
						vm.editing.CurrentSubscriptionId = newSub.Id;

						vm.loadSubscriptionHistory();

						vm.selectedPlan = 0;
					}
				})
			},

			balanceOperationCreate: function () {
				var vm = this;

				Loading.Show();

				Session.Do('Balance', 'Change',{
					id: this.editing.Id,
					amount: this.newBalanceOperation.Amount,
					description: this.newBalanceOperation.Description
				}, function (result) {
					Loading.Hide();
					if (result && result.Id){
						vm.editing.Balance += parseInt(vm.newBalanceOperation.Amount);
						vm.balanceOperationHistory.unshift(new BalanceOperation(result));
						vm.newBalanceOperation = new BalanceOperation();
					}
				})
			},




            ///// Buy
            calculateCredits: function (price, user) {
                var multiplier = 1;

                if (user.CurrentSubscription){
                    if (user.CurrentSubscription.Plan.CreditsBonus){
                        multiplier = 1+(user.CurrentSubscription.Plan.CreditsBonus/100);
                    }
                }

                return Math.floor(Plan.__pointsRatio * price * multiplier);
            },
            purchase: function () {
                if (!this.buy.selectedAmount){
                    toast('error', 'Selecione uma quantia', 'Erro', 15000);
                    return;
                }
                if (!this.$refs.cc.isFilled){
                    toast('error', 'Preencha seus dados', 'Erro', 15000);
                    return;
                }

                var vm = this;

                var holder = this.$refs.cc.holder;
                var address = this.$refs.cc.address;
                var hash = this.$refs.cc.getHash();
                var amount = this.buy.selectedAmount;
                var user = this.editing;

                Loading.Show('Validando cartão...');

                this.$refs.cc.getCreditCardToken(function (token) {
                    if (!token){
                        toast('error', 'Erro ao processar o cartão...', 'Erro', 15000);
                        Loading.Hide();
                        return;
                    }

                    Loading.Show('Processando assinatura...');

                    Session.Do('Payment', 'BuyCredits',{
                        holder: JSON.stringify(holder.Serialize()),
                        address: JSON.stringify(address.Serialize()),
                        cardToken: token,
                        hash: hash,
                        amount: amount,
                        user: user.Id
                    }, function (result) {
                        Loading.Hide();

                        if (result){
                            toast('success', 'Assim que a transação for aprovada o valor será creditado', 'Sucesso', 15000);
                            vm.closePurchase();
                        }
                    });
                });
            },
            openPurchase: function () {
                this.$refs.plans.hideNext();
                this.$refs.purchase.showNext();
                this.$refs.cc.clear();
                this.buy.selectedAmount = 0;
            },
            closePurchase: function () {
                this.$refs.plans.showNext();
                this.$refs.purchase.hideNext();
            }
		},
		mounted: function () {
			this.load();
		}
	});
</script>



<?=PagSeguroHandler::javascript()?>