var Session = new OptionsReceiver({
    URL: '',
    Token: '',

    actionPrefix: null,
    actionSuffix: null,
    controllerMethodPattern: '{0}/{1}',

    _getQueryString: function (params) {
        var queryStringParts = [];
        for (var i in params){
            if (params.hasOwnProperty(i)){
                queryStringParts.push(
                    encodeURI(i)+'='+encodeURI(params[i])
                )
            }
        }

        return (queryStringParts.length ? '?' : '')+queryStringParts.join('&');
    },
    GetActionUrl: function(controller, method,params){
        if (!params) params = [];
        
        var url = this.URL.split("/");

        if (!url[url.length-1]) url.splice(url.length-1, 1);

        if(this.actionPrefix !== null) url.push(this.actionPrefix);

        url.push(this.controllerMethodPattern.format([controller, method]));

        if(this.actionSuffix !== null) url.push(this.actionSuffix);

        return url.join('/')+this._getQueryString(params);
    },
    GetPageUrl: function(Page, params){
        return this.URL+Page+"/"+this._getQueryString(params);
    },
    Do: function(controller, action, data, success, method){
        if (!method) method = "POST";
        if (!data) {
            data = {}
        }
        data._token = this.Token;

        $.ajax({
            type: method,
            url: Session.GetActionUrl(controller, action),
            data: data,
            success: success,
            dataType: 'json'
        });
    }
}).applyOptions(window['Session']);


function InlineJsonToObject(name) {
    var data = $("script#"+name+"-json").html();
    return JSON.parse(data);
}
function InlineJsonToEntity(name) {
    return Entity.FromArray(InlineJsonToObject(name));
}
function InlineJsonToEntityList(name) {
    return InlineJsonToObject(name).ToEntityArray();
}

if (window.location.toString() == "#_=_"){
    window.location.hash = '';
}